package com.example.leeyuanair.englishhelper;

import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.example.leeyuanair.englishhelper.act_allwords.ActWordInfo;

import java.util.ArrayList;

public class ActListOfWordPackage extends AppCompatActivity implements ListView.OnItemClickListener {
    //Global Variables
    ArrayList<String> information;
    //TextView文字標籤元件
    TextView lblWordPackageExplanation;
    //ListView清單元件
    ListView lstWordPackage;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_act_list_of_word_package);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        //連結文字標籤元件
        lblWordPackageExplanation = (TextView) findViewById(R.id.lblWordPackageExplanation);
        lstWordPackage = (ListView) findViewById(R.id.lstWordPackage);
        lstWordPackage.setOnItemClickListener(this);
        //讀取上一層的資料
        int index = getIntent().getExtras().getInt("Index");
        setTitle("單字包裹 - " + MainActivity.WORD_PACKAGES_NAMES.get(index));
        //取得使用者所選的
        information = MainActivity.WORD_PACKAGES.get(MainActivity.WORD_PACKAGES_NAMES.get(index));
        ArrayAdapter<String> wordsArrayAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1);
        lblWordPackageExplanation.setText(information.get(0));
        //逐次尋找該字資源並映到清單上
        int power, point_power;
        //設定詞性取得的優先權
        switch (information.get(1)) {
            case "n":
                power = 0;
                break;
            case "a":
                power = 1;
                break;
            case "v":
                power = 2;
                break;
            case "adv":
                power = 3;
                break;
            case "prep":
                power = 4;
                break;
            default:
                power = 0;
                break;
        }
        //pOS = Part Of Speech，字串陣列，表示儲存某單字的所有詞性中文意思
        String[] pOS;
        //循序取得資訊並存路wordsArrayAdapter裡
        for (int i = 2; i < information.size(); i++) {
            pOS = MainActivity.ALL_WORDS.get(information.get(i));
            point_power = power;
            while (pOS[point_power] == null || pOS[point_power].equals(""))
                point_power++;
            wordsArrayAdapter.add(information.get(i) +" "+ Number2pOS(point_power) + " " + pOS[point_power]);
        }
        lstWordPackage.setAdapter(wordsArrayAdapter);
    }
    //函式 - 數值轉詞性縮寫
    String Number2pOS(int number){
        switch (number){
            case 0: return "(n.)";
            case 1: return "(adj.)";
            case 2: return "(v.)";
            case 3: return "(adv.)";
            case 4: return "(prep.)";
            default:return "(error)";
        }
    }

    //當清單上的某項被按下時
    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        Intent it = new Intent(this, ActWordInfo.class);
        it.putExtra("isAddingMode", false);
        it.putExtra("SelectedWord", information.get(position+2));
        startActivity(it);
    }

    //當【返回】按鈕按下時
    public void btnBack11_Click(View view) {finish();}
}
