package com.example.leeyuanair.englishhelper;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.content.res.AssetManager;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import com.example.leeyuanair.englishhelper.access.WordInfo;
import com.example.leeyuanair.englishhelper.act_4selections.Act4Selection;
import com.example.leeyuanair.englishhelper.act_allwords.ActAllVoca;
import com.example.leeyuanair.englishhelper.act_allwords.ActWordInfo;
import com.example.leeyuanair.englishhelper.act_memory.ActMemorySetting;
import com.example.leeyuanair.englishhelper.act_spelling.ActSpellingSetting;

import java.io.*;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Date;
import java.util.LinkedHashMap;
import java.util.Random;

public class MainActivity extends AppCompatActivity {
    //Global Static Variables 公有靜態變數
    public static LinkedHashMap<String, String[]> ALL_WORDS;
    public static ArrayList<String> WORDS;
    public static LinkedHashMap<String, ArrayList<String>> GROUPS;
    public static ArrayList<String> GROUP_NAMES;
    public static int groupCount;
    public static LinkedHashMap<String, ArrayList<String>> WORD_PACKAGES;
    public static ArrayList<String> WORD_PACKAGES_NAMES;
    //Buttn按鈕元件
    Button btn4Select;
    Button btnFillUp;
    Button btnMemory;
    Button btnSpelling;
    Button btnAllVoca;
    //TextView文字標籤元件
    TextView lblVersion;
    TextView lblWordMessage;
    //其他變數
    AssetManager am;
    public WordInfo[] words;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        setTitle("英文幫手");
        //鏈結按鈕物件
        btn4Select = (Button) findViewById(R.id.btn4Select);
        btnMemory = (Button) findViewById(R.id.btnMemory);
        btnSpelling = (Button) findViewById(R.id.btnSpelling);
        btnAllVoca = (Button) findViewById(R.id.btnAllVoca);
        //鏈結文字標籤物件
        lblVersion = (TextView) findViewById(R.id.lblVersion);
        lblWordMessage = (TextView) findViewById(R.id.lblWordMessage);
        //其他設定
        am = getAssets();
        //####讀取單字資料####
        try{
            InputStream is = am.open("Words.txt");
            int length = is.available();
            byte[] data = new byte[length];
            is.read(data); is.close();
            ALL_WORDS = WordInfo.analyzeWordInfo(new String(data));         //將單字資料解析並將其結果放回ALL_WORDS裡
            WORDS = new ArrayList<>();                                     //建立WORDS英文單字
            WORDS.addAll(ALL_WORDS.keySet());                            //將ALL_WORDS的鍵值加入到WORDS裡
        }catch(Exception ex){
            setTitle("Fail");
            lblVersion.setText(ex.toString());
        }
        String[] item = new String[5];
        //####是否初次使用此APP的確認函式，環境初始化函式####
        firstInitialize();
        //####讀取單字群組####
        GROUPS = new LinkedHashMap<>();
        GROUP_NAMES = new ArrayList<>();
        try{
            //讀取群組單字檔案
            InputStream is = new FileInputStream(getFilesDir()+"/groups.txt");
            byte[] data = new byte[is.available()];
            is.read(data); is.close();
            String info[] = ((new String(data)).replace("\r","")).split("\n");      //解析字串
            groupCount = Integer.parseInt(info[0]);                                    //群組數量
            for(int i=1;i<info.length;i+=2) {
                GROUP_NAMES.add(info[i]);
                GROUPS.put(info[i], new ArrayList<>(Arrays.asList(info[i + 1].split(" "))));
            }
        }catch(Exception ex){
            Toast.makeText(MainActivity.this, "群組單字資料讀取錯誤", Toast.LENGTH_SHORT).show();
        }
        //####讀取單字包裹檔案####
        WORD_PACKAGES = new LinkedHashMap<>();          //建構WORD_PACKAGES
        WORD_PACKAGES_NAMES = new ArrayList<>();
        try{
            InputStream is = am.open("word_packages.txt");                      //開起在assets的檔案word_packages.txt
            byte[] data = new byte[is.available()];                             //建立data變數，並以該資料長度作為陣列的長度
            is.read(data); is.close();                                           //以byte[]的形式將資料讀出。讀出後將資料流關閉
            //解析字串
            String[] infos = ((new String(data)).replace("\r","")).split("\n");  //以換行符號為單位拆成若干個字串陣列infos[]
            String wordPackageName;  ArrayList<String> content;                  //建立wordPackageName與content來暫存包裹名稱及其內容
            String[] spis1, spis2;                                               //spis1與spis2表示infos[]內容的再細分，其中以空白符號作為單位
            //##循序讀取##
            for(int i=1;i<infos.length;i+=2){
                content = new ArrayList<>();
                spis1 = infos[i].split(" ");        //解析
                spis2 = infos[i+1].split(" ");      //解析
                wordPackageName = spis1[0];
                WORD_PACKAGES_NAMES.add(wordPackageName);
                content.add(spis1[1]); content.add(spis1[2]);
                content.addAll(Arrays.asList(spis2));               //利用Arrays類別裡的靜態函數asList()來將陣列spis2轉為表準清單
                WORD_PACKAGES.put(wordPackageName, content);   //最後加入到WORD_PACKAGES裡
            }
        }catch(Exception ex){
            Toast.makeText(MainActivity.this, "單字包裹資料讀取錯誤", Toast.LENGTH_SHORT).show();
        }
        //####判別「每日一字」是否需要更新，如果不需要則顯示紀錄的單字；如果需要則更新並顯示其單字
        Calendar c = Calendar.getInstance();
        int y=c.get(c.YEAR), m=c.get(c.MONTH), d=c.get(c.DAY_OF_MONTH);
        String dayCheck = (String.valueOf(y)+ ((m+1)>9 ? String.valueOf(m+1) : "0"+String.valueOf(m+1))+ (d>9 ? String.valueOf(d) : "0"+String.valueOf(d)));
        try{
            InputStream is = new FileInputStream(getFilesDir()+"/daily.txt");
            byte[] data = new byte[is.available()];
            is.read(data); is.close();
            String[] dailyInfo = ((new String(data)).replace("\r","")).split("\n");
            //確認紀錄日期是否為今日
            if(dailyInfo[0].equals(dayCheck)){
                lblWordMessage.setText(dailyInfo[1]);
            }else{  //若不是，則更新日期與單字
                Random rnd = new Random(); rnd.setSeed(rnd.nextInt(100));
                String newWord = WORDS.get(rnd.nextInt(WORDS.size()));
                OutputStream os = new FileOutputStream(getFilesDir()+"/daily.txt", false);
                os.write((dayCheck+"\r\n"+newWord).getBytes());
                os.flush(); os.close();
                lblWordMessage.setText(newWord);
            }
        }catch(Exception ex){
            Toast.makeText(MainActivity.this, "每日一字讀取錯誤", Toast.LENGTH_SHORT).show();
        }
    }

    //當【字義選擇】按鈕按下時，開啟字義選擇頁面。
    public void btn4Select_Click(View view) {
        Intent it = new Intent(this, Act4Selection.class);
        startActivity(it);
    }

    //當【記憶練習】按鈕按下時，開啟記憶練習設定頁面。
    public void btnMemory_Click(View view) {
        Intent it = new Intent(this, ActMemorySetting.class);
        startActivity(it);
    }

    //當【拼字測驗】按鈕按下時，開啟拼字練習設定頁面
    public void btnSpelling_Click(View view) {
        Intent it = new Intent(this, ActSpellingSetting.class);
        startActivity(it);
    }

    //當【文字包裹】按鈕按下時，開啟文字包裹頁面
    public void btnWordPackage_Click(View view) {
        Intent it = new Intent(this, ActWordPackages.class);
        startActivity(it);
    }

    //當【單字列表】按鈕按下時，開啟單字列表頁面。
    public void btnAllVoca_Click(View view) {
        startActivity(new Intent(this, ActAllVoca.class));
    }

    //當lblWordMessage標籤物件按下時
    public void lblWordMessage_Click(View view) {
        Intent it = new Intent(this, ActWordInfo.class);
        it.putExtra("isAddingMode", false);
        it.putExtra("SelectedWord", lblWordMessage.getText().toString());
        startActivity(it);
    }

    //環境初始化 - 當使用者為第一次使用此Application時，初始化所有相關的變數。
    protected void firstInitialize(){
        try{
            //確認群組檔案是否存在，如果不存在就新增一個新的群組檔案
            File groups = new File(getFilesDir()+"/groups.txt");
            if(!groups.exists()){
                groups.createNewFile();
                OutputStream os = new FileOutputStream(getFilesDir()+"/groups.txt");
                os.write(("0").getBytes());
                os.flush(); os.close();
            }else{
                //groups.delete();
                //Toast.makeText(this,"Deleted",Toast.LENGTH_SHORT).show();
            }
            //確認每日紀錄的檔案是否存在，如果不存在則新創一個
            File daily = new File(getFilesDir()+"/daily.txt");
            if(!daily.exists()){
                daily.createNewFile();
                OutputStream os = new FileOutputStream(getFilesDir()+"/daily.txt");
                String word = WORDS.get((new Random()).nextInt(WORDS.size()));      //隨機選取一個單字
                Calendar c = Calendar.getInstance();                                       //取得當前時間
                int y=c.get(c.YEAR), m=c.get(c.MONTH), d=c.get(c.DAY_OF_MONTH);
                os.write((String.valueOf(y) +
                        ((m + 1) > 9 ? String.valueOf(m + 1) : "0" + String.valueOf(m + 1)) +
                        (d > 9 ? String.valueOf(d) : "0" + String.valueOf(d)) +
                        "\r\n" + word).getBytes());
                os.flush(); os.close();
            }
        }catch(Exception ex){
            lblVersion.setText(ex.toString());
        }
    }

    //當版本訊息lblVersion按下時
    public void lblVersion_Click(View view) {
        AlertDialog.Builder msgBox = new AlertDialog.Builder(this)
                .setTitle("關於英文幫手")
                .setMessage("此應用程式由Nebula3122製作。\r\n若有錯誤的地方就麻煩通知我吧，\r\n我會進行修正的動作，謝謝!")
                .setPositiveButton("OK", new DialogInterface.OnClickListener() {@Override public void onClick(DialogInterface dialog, int which) {}})
                .setNeutralButton("Email", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        Intent emailIntent = new Intent(android.content.Intent.ACTION_SEND);
                        emailIntent.setType("plain/text");
                        emailIntent.putExtra(android.content.Intent.EXTRA_EMAIL, new String[]{"alan159753@gmail.com"});
                        emailIntent.putExtra(android.content.Intent.EXTRA_SUBJECT, "英文幫手 - 回應");
                        emailIntent.putExtra(android.content.Intent.EXTRA_TEXT, "內文");
                        startActivity(Intent.createChooser(emailIntent, "Email回覆"));
                    }
                });
        msgBox.show();
    }
}
