package com.example.leeyuanair.englishhelper.access;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;

/**
 * Created by Lee Yuan Air on 2016/2/21.
 *
 */
public class WordInfo {
    public String word;
    public String noun, adjective, verb, adverb, preposition;
    public WordInfo(String word, String noun, String adjective, String verb, String adverb, String preposition){
        this.word = word;
        this.noun = noun;
        this.adjective = adjective;
        this.verb = verb;
        this.adverb = adverb;
        this.preposition = preposition;
    }
    public void setWord(String word){this.word = word;}
    public void setNoun(String noun){this.noun = noun;}
    public void setAdjective(String adjective){this.adjective = adjective;}
    public void setVerb(String verb){this.verb = verb;}
    public void getAdverb(String adverb){this.adverb = adverb;}
    public void setPreposition(String preposition){this.preposition = preposition;};
    public static void sort(WordInfo[] data){
        WordInfo temp;
        for(int i=1;i<data.length;i++){
            for(int q=data.length-1;q>=i;q--){
                if(data[q-1].word.compareTo(data[q].word)>0){
                    temp = data[q-1];
                    data[q-1] = data[q];
                    data[q] = temp;
                }
            }
        }
    }

    //解析字串並轉入HashMap集合物件裡的資料，最後回傳之。
    public static LinkedHashMap<String, String[]> analyzeWordInfo(String inputs){
        String[] info = (inputs.replace("\r","")).split("\n");
        LinkedHashMap<String, String[]> wordinfos = new LinkedHashMap<>();
        String[] spis;
        String word,n,a,v,adv,prep;
        for(int i=1;i<info.length;i++){
            spis = info[i].split(" ");
            word = spis[0];
            n=null; a=null; v=null; adv=null; prep=null;
            for(int q=1;q<spis.length;q+=2){
                switch (spis[q]){
                    case "n" :
                        n = spis[q+1];
                        break;
                    case "a" :
                        a = spis[q+1];
                        break;
                    case "v" :
                        v = spis[q+1];
                        break;
                    case "adv" :
                        adv = spis[q+1];
                        break;
                    case "prep" :
                        prep = spis[q+1];
                        break;
                    default :
                }
            }
            wordinfos.put(word, new String[] {n,a,v,adv,prep});
        }
        return wordinfos;
    }
    public static WordInfo[] analyzeWordInfoString(String inputs) {
        String[] info = (inputs.replace("\r","")).split("\n");
        WordInfo[] wordinfos = new WordInfo[info.length-1];
        String[] spis;
        String word,n,a,v,adv,prep;
        for(int i=1;i<info.length;i++){
            spis = info[i].split(" ");
            word = spis[0];
            n=null; a=null; v=null; adv=null; prep=null;
            for(int q=1;q<spis.length;q+=2){
                switch (spis[q]){
                    case "n" :
                        n = spis[q+1];
                        break;
                    case "a" :
                        a = spis[q+1];
                        break;
                    case "v" :
                        v = spis[q+1];
                        break;
                    case "adv" :
                        adv = spis[q+1];
                        break;
                    case "prep" :
                        prep = spis[q+1];
                        break;
                    default :
                }
            }
            wordinfos[i-1] = new WordInfo(word,n,a,v,adv,prep);
        }
        return wordinfos;
    }
}