package com.example.leeyuanair.englishhelper.act_4selections;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.graphics.Color;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;

import com.example.leeyuanair.englishhelper.MainActivity;
import com.example.leeyuanair.englishhelper.R;

import java.io.FileInputStream;
import java.io.InputStream;

public class Act4Selection extends AppCompatActivity implements SeekBar.OnSeekBarChangeListener, CheckBox.OnCheckedChangeListener {

    //Valuable全域變數
    int Selection;               //使用者的選擇
    String extraMsg;           //額外的訊息
    boolean qualified;          //紀錄是否可以開始測驗
    boolean N , A, V, ADV, PREP;    //表示該群組的某詞性是否可以獨立隨機選取
    //Button按鈕物件
    Button btnChangeGroup1;
    //CheckBox勾選方塊物件
    CheckBox chkOnlyGroupItem1;
    //TextView文字標籤物件
    TextView lblTimePerQ1;
    TextView lblExtraMsg1;
    //EditText文字編輯物件
    EditText txtQAmount1;
    //SeekBar滑桿元件
    SeekBar skbTimeSet1;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_act4_selection);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        setTitle("字義選擇 - 測驗設定");
        //連結按鈕物件
        btnChangeGroup1 = (Button) findViewById(R.id.btnChangeGroup1);
        //連結勾選方塊物件
        chkOnlyGroupItem1 = (CheckBox) findViewById(R.id.chkOnlyGroupItem1);
        chkOnlyGroupItem1.setOnCheckedChangeListener(this);
        //連結文字標籤物件
        lblTimePerQ1 = (TextView) findViewById(R.id.lblTimePerQ1);
        lblExtraMsg1 = (TextView) findViewById(R.id.lblExtraMsg1);
        //連結文字編輯物件
        txtQAmount1 = (EditText) findViewById(R.id.txtQAmount1);
        //連結滑桿元件
        skbTimeSet1 = (SeekBar) findViewById(R.id.skbTimeSet1);
        skbTimeSet1.setOnSeekBarChangeListener(this);
        //初始化變數
        Selection = -1;
        extraMsg = "";
        qualified = true;
        N = false; A = false; V = false; ADV = false; PREP = false;
    }

    //當【+】按鈕按下時
    public void btnAdd1_Click(View view) {
        int num = Integer.parseInt(txtQAmount1.getText().toString()) + 1;
        txtQAmount1.setText(String.valueOf((num < 10000) ? num : 9999));
    }

    //當【-】按鈕按下時
    public void btnSubtract1_Click(View view) {
        int num = Integer.parseInt(txtQAmount1.getText().toString()) - 1;
        txtQAmount1.setText(String.valueOf((num > 0) ? num : 1));
    }

    //當按鈕物件btnChangeGroup1_Click按下時
    public void btnChangeGroup1_Click(View view) {
        final ArrayAdapter<String> grouplist = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1);
        byte[] data;
        grouplist.add("所有單字");
        //讀取群組檔案
        try{
            InputStream is = new FileInputStream(getFilesDir()+"/groups.txt");
            data = new byte[is.available()];
            is.read(data); is.close();
            final String[] info = ((new String(data)).replace("\r","")).split("\n");
            for(int i=1;i<info.length;i+=2)
                grouplist.add(info[i]);
            //建立對話方塊
            AlertDialog.Builder alert = new AlertDialog.Builder(this);
            alert.setTitle("選擇群組");
            alert.setAdapter(grouplist, new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {
                    Selection = which - 1;
                    //設定群組選擇按鈕之文字
                    btnChangeGroup1.setText(grouplist.getItem(which).toString());
                    //若使用者不是選擇「所有單字」，即選擇序數大於等於0時。
                    if(Selection>=0){
                        //確認該選擇的群組內容不為空
                        if(!info[Selection*2+2].equals("0")){
                            int n=0, a=0, v=0, adv=0, prep=0;                   //紀錄個詞性在群組內的數量
                            String[] spis = info[Selection*2+2].split(" ");     //分解群組內容(字串)
                            //若群組單字量大於4時，符合最低群組取用條件
                            if(spis.length>4){
                                //標示該群組可進行測驗
                                qualified = true;
                                //逐一地解析內容，並篩選、紀錄詞性總數
                                for(int i=0;i<spis.length;i++){
                                    String[] wordinfo = MainActivity.ALL_WORDS.get(spis[i]);
                                    n += (wordinfo[0]!=null) ? 1 : 0;
                                    a += (wordinfo[1]!=null) ? 1 : 0;
                                    v += (wordinfo[2]!=null) ? 1 : 0;
                                    adv += (wordinfo[3]!=null) ? 1 : 0;
                                    prep += (wordinfo[4]!=null) ? 1 : 0;
                                }
                                //依詞性數量來判斷提醒使用者的訊息
                                N = n>3; A = a>3; V = v>3; ADV = adv>3; PREP = prep>3;
                                extraMsg = ((N && A && V && ADV && PREP) ? "" : "由於此群組內的") +
                                        (N ? "" : " 名詞") + (A ? "" : " 形容詞") + (V ? "" : " 動詞") + (ADV ? "" : " 副詞") + (PREP ? "" : " 介係詞") +
                                        ((N && A && V && ADV && PREP) ? "" : "類的數量小於3個，因此系統若隨機選到該類詞性時，其選項會包括群組外的同詞性單字。");
                                //若【選項中僅出現群組裡的單字】的格子勾選時，顯示其訊息
                                lblExtraMsg1.setTextColor(Color.argb(255,160,160,160));
                                if(chkOnlyGroupItem1.isChecked()){
                                    lblExtraMsg1.setText(extraMsg);
                                }
                            }else{  //若群組單字量小於等於4時，則告知使用者該群組不符合最低條件。
                                //標示該群組不能進行測驗
                                qualified = false;
                                lblExtraMsg1.setTextColor(Color.RED);
                                extraMsg = "群組內的單字量必須大於4個才能開始測驗!";
                                lblExtraMsg1.setText(extraMsg);
                            }
                        }else{  //若該群組為空時，也就是單字量為0時，告知使用者該群組不可用
                            //標示該群組不能進行測驗
                            qualified = false;
                            lblExtraMsg1.setTextColor(Color.RED);
                            extraMsg = "由於所選群組內無任何單字，因此無法開始測驗!";
                            lblExtraMsg1.setText(extraMsg);
                        }
                    }else{  //當使用者選擇「所有單字」選項時
                        //標示該群組可進行測驗
                        qualified = true;
                        lblExtraMsg1.setTextColor(Color.argb(255,160,160,160));
                        lblExtraMsg1.setText("");
                        extraMsg = "";
                    }
                }
            });
            //顯示對話方塊
            alert.show();
        }catch(Exception ex){
            Toast.makeText(Act4Selection.this, "群組檔案讀取錯誤。", Toast.LENGTH_SHORT).show();
        }

    }

    //當【選項中僅出現群組裡的單字】勾選方塊按下時
    @Override
    public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
        if(qualified){
            if(isChecked) {
                lblExtraMsg1.setText(extraMsg);
            } else {
                lblExtraMsg1.setText("");
            }
        }
    }

    //當【返回】按鈕按下時
    public void btnBack_Click(View view) {finish();}

    //當【說明】按鈕按下時
    public void btnExplanation1_Click(View view) {
        final AlertDialog.Builder adExp1, adExp2, adExp3;
        //設定對話方塊的內容
        adExp3 = new AlertDialog.Builder(this)
                .setTitle("說明")
                .setMessage("在設定的部分，你可以選擇目前所定義的群組單字、設定題目數及設定每一題的回答時間。" +
                        "完成之後你就可以按下【開始測驗】來進行測驗了!")
                .setPositiveButton("完成", new DialogInterface.OnClickListener() {@Override public void onClick(DialogInterface dialog, int which) {}});
        adExp2 = new AlertDialog.Builder(this)
                .setTitle("說明")
                .setMessage("若你選擇正確，增加一次回答正確的紀錄；若選擇錯誤，則會公布正確答案並增加一次回答錯誤的紀錄。")
                .setPositiveButton("下一頁", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        adExp3.show();
                    }
                });
        adExp1 = new AlertDialog.Builder(this)
                .setTitle("說明")
                .setMessage("此測驗方法與四選一選擇題一樣，題目會秀出英文單字與其詞性，" +
                        "而下方有四個寫著不同中文意義的按鈕，你只需要選出與題目相符的答案。")
                .setPositiveButton("下一步", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        adExp2.show();
                    }
                });
        adExp1.show();
    }

    //當【開始測驗】按鈕按下時
    public void btnStartTest1_Click(View view) {
        //如果所選群組符合條件
        if(qualified){
            Intent it = new Intent(Act4Selection.this,ActMultipleChoice.class);
            it.putExtra("Selection", Selection);                                           //使用者所選的群組
            it.putExtra("Amount", Integer.valueOf(txtQAmount1.getText().toString()));   //測驗的題目總數
            it.putExtra("SecPerQ", skbTimeSet1.getProgress());                          //一題的限制秒數
            //選項的單字是否僅出現群組中所有的單字
            if(chkOnlyGroupItem1.isChecked()){
                it.putExtra("cN", N); it.putExtra("cA", A); it.putExtra("cV", V);
                it.putExtra("cADV", ADV); it.putExtra("cPREP", PREP);
            }else{
                it.putExtra("cN", false); it.putExtra("cA", false); it.putExtra("cV", false);
                it.putExtra("cADV", false); it.putExtra("cPREP", false);
            }
            startActivity(it);
        }
    }

    ////SeekBar滑桿物件的事件處理副程式
    //當滑感滑動時
    @Override
    public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        if(progress==0){
            lblTimePerQ1.setText("每題答題時間: 無限制");
        }else{
            lblTimePerQ1.setText("每題答題時間: "+progress+"秒");
        }
    }

    @Override
    public void onStartTrackingTouch(SeekBar seekBar) {}

    @Override
    public void onStopTrackingTouch(SeekBar seekBar) {}

    ////#######################


}
