package com.example.leeyuanair.englishhelper.act_4selections;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.pm.ActivityInfo;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.example.leeyuanair.englishhelper.R;

import java.util.ArrayList;

public class Act4SelectionResult extends AppCompatActivity implements ListView.OnItemClickListener {
    //Global Variables
    ArrayList<String[]> QuestionList;
    ArrayList<Integer> AnswerList;
    ArrayList<Integer> UserAnswerList;
    //TextView文字標籤物件
    TextView lblQuestionAmount1;
    TextView lblRights1;
    TextView lblWrongs1;
    //ListView清單物件
    ListView lstAnswerLog1;
    //ArrayAdapter清單陣列連結物件
    ArrayAdapter<String> answerLogAdapter;
    //AlertDialog.Builder對話方塊建立物件
    AlertDialog.Builder aswInfo;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_act4_selection_result);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        setTitle("字義選擇 - 測驗結果");
        //連結文字標籤物件
        lblQuestionAmount1 = (TextView) findViewById(R.id.lblQuestionAmount1);
        lblRights1 = (TextView) findViewById(R.id.lblRights1);
        lblWrongs1 = (TextView) findViewById(R.id.lblWrongs1);
        //連結清單物件
        lstAnswerLog1 = (ListView) findViewById(R.id.lstAnswerLog1);
        //取得測驗後的資料
        Bundle msg = getIntent().getExtras();
        QuestionList = (ArrayList<String[]>) msg.get("QuestionList");
        AnswerList = (ArrayList<Integer>) msg.get("AnswerList");
        UserAnswerList = (ArrayList<Integer>) msg.get("UserAnswerList");
        lblQuestionAmount1.setText(String.valueOf(msg.getInt("maxQ")));
        lblRights1.setText(String.valueOf(msg.getInt("rights")));
        lblWrongs1.setText(String.valueOf(msg.getInt("maxQ")-msg.getInt("rights")));
        //設定ArrayAdapter，並將其連結至lstAnswerLog1裡
        answerLogAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1);
        String[] itemSlot;
        for(int i=0; i<QuestionList.size(); i++){
            itemSlot = QuestionList.get(i);
            answerLogAdapter.add(((AnswerList.get(i).equals(UserAnswerList.get(i))) ? "O " : "X ")+(i+1)+". "+itemSlot[0]+" "+itemSlot[AnswerList.get(i)]);
        }
        lstAnswerLog1.setAdapter(answerLogAdapter);
        //將lstAnswerLog1的點選項目事件連結到此類別下的onItemClick()處
        lstAnswerLog1.setOnItemClickListener(this);
        //初始化對話方塊物件
        aswInfo = new AlertDialog.Builder(this);
        aswInfo.setPositiveButton("OK", new DialogInterface.OnClickListener() {@Override public void onClick(DialogInterface dialog, int which) {}});
    }

    //當lstAnswerLog1被按下某一個項目時
    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        try {
            if (AnswerList.get(position).equals(UserAnswerList.get(position))) {
                aswInfo.setTitle("此題答對");
                aswInfo.setMessage("答案: " + QuestionList.get(position)[AnswerList.get(position)]);
            } else {
                aswInfo.setTitle("此題答錯");
                aswInfo.setMessage("正確答案: " + QuestionList.get(position)[AnswerList.get(position)] + "\r\n你的答案: " +
                        ((UserAnswerList.get(position).equals(-1)) ? "*超出時間" : QuestionList.get(position)[UserAnswerList.get(position)]));
            }
            aswInfo.show();
        }catch(Exception ex){
            Toast.makeText(Act4SelectionResult.this, ex.toString(), Toast.LENGTH_SHORT).show();
        }
    }

    void keep(){

    }

    //當【返回至設定頁面】按鈕按下時
    public void btnBack5_Click(View view) {
        finish();
    }
}
