package com.example.leeyuanair.englishhelper.act_4selections;

import android.app.AlertDialog;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.widget.Button;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;

import com.example.leeyuanair.englishhelper.MainActivity;
import com.example.leeyuanair.englishhelper.R;

import java.util.ArrayList;
import java.util.Random;
import java.util.Timer;
import java.util.TimerTask;

public class ActMultipleChoice extends AppCompatActivity {
    //Global Variable
    int maxQ, Q;                            //總題數, 目前答題
    int timelimit, timecount;                 //時間倒數值, 計時值
    int rights;                               //答對題數
    boolean cN, cA, cV, cADV, cPREP;    //該詞性是否只取用群組中的單字
    boolean checks[];
    public int delay;                        //延遲時間
    public int mode;                        //表示目前計數的模式
    int backUpTimeCount;                  //計算使用者按下返回鍵時再按下一次返回鍵間的間隔時間
                                            //若在該時間之內則讓使用者退出測驗
    //題目方面的變數
    ArrayList<String[]> QuestionList;        //題目清單
    ArrayList<Integer> AnswerList;          //答案清單
    ArrayList<Integer> UserAnswerList;      //紀錄使用者的回答
    //Timer計時器
    Timer countdownTimer;
    //TextView文字標籤物件
    TextView lbl4SelStatus1, lbl4SelStatus2;
    TextView lbl4SelQuestion;
    //Button按鈕物件
    Button btnSelection1, btnSelection2, btnSelection3, btnSelection4;
    //ProgressBar進度顯示物件
    ProgressBar pgbCountdown1;
    //AlertDialog.Builder對話框建立物件
    AlertDialog AnswerShows;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_act_multiple_choice);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        setTitle("字義選擇");
        Bundle msg = getIntent().getExtras();
        mode = 1; delay=4;
        //##連結文字標籤物件
        lbl4SelStatus1 = (TextView) findViewById(R.id.lbl4SelStatus1);
        lbl4SelStatus2 = (TextView) findViewById(R.id.lbl4SelStatus2);
        lbl4SelQuestion = (TextView) findViewById(R.id.lbl4SelQuestion);
        //##連結按鈕物件
        btnSelection1 = (Button) findViewById(R.id.btnSelection1);
        btnSelection2 = (Button) findViewById(R.id.btnSelection2);
        btnSelection3 = (Button) findViewById(R.id.btnSelection3);
        btnSelection4 = (Button) findViewById(R.id.btnSelection4);
        //##連結進度表示物件 並 為其建立獨立的執行續以連結倒數的動作
        pgbCountdown1 = (ProgressBar) findViewById(R.id.pgbCountdown1);
        //##初始化對話框物件
        AnswerShows = (new AlertDialog.Builder(this)).create();
        AnswerShows.setTitle("答案");
        AnswerShows.setCancelable(false);
        //##取得資料
        maxQ = msg.getInt("Amount");
        timelimit = msg.getInt("SecPerQ") * 1000;
        checks = new boolean[5];
        checks[0] = msg.getBoolean("cN"); checks[1] = msg.getBoolean("cA"); checks[2] = msg.getBoolean("cV");
        checks[3] = msg.getBoolean("cADV"); checks[4] = msg.getBoolean("cPREP");
        //##初始化變數
        timecount = 0; Q = 0;
        rights = 0;
        countdownTimer = new Timer();
        countdownTimer.schedule(countdownTask, 0, 1);
        //將進度顯示物件的最大直設為timelimit
        pgbCountdown1.setMax(1000);
        //##初始化介面
        lbl4SelStatus1.setText("總題數: "+maxQ+" ,目前答題: 0");
        //##初始化題目列表
        InitQuestionList(msg.getInt("Selection"));
    }

    //TimerTask計時器工作物件 - 當Timer倒數計時至一定時間時所執行的動作，其中利用此物件作為Timer工作表。
    public final TimerTask countdownTask = new TimerTask() {
        @Override
        public void run() {
            //####透過runOnUiThread來取得合法控制使用者介面物件的權利####
            runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    //若backUpTimeCount大於0，則將其減1
                    if (backUpTimeCount > 0) backUpTimeCount--;
                    //####以下為測驗判斷程序####
                    //依照mode是否為真，將timecount+1或-1
                    timecount += mode;
                    //如果延遲時間計數delay大於0 - 為使用者剛進入時的緩衝時間
                    if (delay > 0) {
                        //每次做1秒的倒數，當倒數至1秒時，delay-1，時間計數timecount重設回0，此動作直到delay==0為止。
                        if (timecount == 1000) {
                            delay--;
                            timecount = 0;
                            //當delay計數完時，將進度顯示物件的最大值設為使用者所限制的時間timelimit
                            if (delay == 0) {
                                pgbCountdown1.setMax((timelimit>0) ? timelimit : 500);
                                if (timelimit == 0) {
                                    mode = 0;
                                    timecount=1;
                                }
                                lbl4SelQuestion.setText(QuestionList.get(Q)[0]);
                                btnSelection1.setText(QuestionList.get(Q)[1]);
                                btnSelection2.setText(QuestionList.get(Q)[2]);
                                btnSelection3.setText(QuestionList.get(Q)[3]);
                                btnSelection4.setText(QuestionList.get(Q)[4]);
                            } else {
                                //若delay沒有計數完，則顯示倒數數值delay
                                lbl4SelQuestion.setText(String.valueOf(delay));
                            }
                        }
                    } else {  //如果delay==0時(即delay<0時)，也就是使用者已經進入測驗狀態
                        if (mode == 1) {
                            //判別計數時間是否到達限制時間
                            if (timecount > timelimit) {
                                //如果以到達時間的話，將mode(測驗模式)設為false，表示目前暫停測驗
                                //並告知使用者的作答時間已經超過預設時間、顯示答案及更新答題狀態
                                //最後設定2秒短暫延遲時間讓使用者可以看得到答案
                                mode = -1;
                                UserAnswerList.add(-1);
                                AnswerShows.setTitle("超過時間!");
                                AnswerShows.setMessage("答案: " + QuestionList.get(Q)[AnswerList.get(Q)]);
                                AnswerShows.show();
                                pgbCountdown1.setProgress(2000);
                                pgbCountdown1.setMax(2000);
                                timecount = 2000;
                            }
                        } else {
                            //若顯示答案的時間完畢後
                            if (timecount == 0) {
                                //確認全部題目是否答完
                                if (Q == maxQ - 1) {
                                    AnswerShows.dismiss(); //把AnswerShows對話方塊取消掉
                                        countdownTimer.cancel();
                                        countdownTimer.purge();
                                        //開啟結果顯示頁面
                                        Intent it = new Intent(ActMultipleChoice.this, Act4SelectionResult.class);
                                        it.putExtra("QuestionList", QuestionList);
                                        it.putExtra("AnswerList", AnswerList);
                                        it.putExtra("UserAnswerList", UserAnswerList);
                                        it.putExtra("maxQ", maxQ);
                                        it.putExtra("rights", rights);
                                        startActivityForResult(it, 0);
                                } else {    //如果題目尚未全部答完的話，則目前題號+1，並更新題目內容
                                    mode = (timelimit == 0) ? 0 : 1;            //把mode轉為true，為答題模式
                                    timecount = (timelimit == 0) ? 1 : 0;       //若時限為無限制，則把timecount設為1，以免誤判
                                    AnswerShows.dismiss(); //把AnswerShows對話方塊取消掉
                                    //更新題目內容
                                    Q++;                    //題號+1
                                    //依照目前的題號，從題目清單裡提出題目與四個選項，並放入所設定的位置
                                    lbl4SelQuestion.setText(QuestionList.get(Q)[0]);
                                    btnSelection1.setText(QuestionList.get(Q)[1]);
                                    btnSelection2.setText(QuestionList.get(Q)[2]);
                                    btnSelection3.setText(QuestionList.get(Q)[3]);
                                    btnSelection4.setText(QuestionList.get(Q)[4]);
                                    //更新答題數狀態
                                    lbl4SelStatus1.setText("總題數: " + maxQ + ", 目前答題: " + (Q + 1));
                                    lbl4SelStatus2.setText("答對題數: " + String.valueOf(rights) + " ,答錯題數: " + String.valueOf(Q - rights));
                                    pgbCountdown1.setMax((timelimit>0) ? timelimit : 500);    //將進度顯示物件的最大值設為timelimit
                                }
                            }
                        }
                    }
                    //更新進度顯示物件的進度數值
                    pgbCountdown1.setProgress(timecount);
                }
            });
            //############################################################
        }
    };

    //程序 - 初始化題目列表
    void InitQuestionList(int index){
        ArrayList<String> tarGroup = (index>=0) ? (MainActivity.GROUPS.get(MainActivity.GROUP_NAMES.get(index))) : (MainActivity.WORDS);      //取得使用者所選的群組
        Random rnd = new Random();              //亂數產生器
        rnd.setSeed(rnd.nextInt(100));
        QuestionList = new ArrayList<>();       //題目清單
        AnswerList = new ArrayList<>();        //答案清單回答紀錄(清單)
        UserAnswerList = new ArrayList<>();    //使用者
        int type, ans;       //type表示目前所視單字的某項詞性: 0為名詞、1為形容詞、2為動詞、3為副詞、4為介係詞; ans表示答案正確項
        //判別使用者所選定的題數數量是否大於群組內所有單字的數量
        ArrayList<String> rndGroup = new ArrayList<>();        //初始化基本亂數題庫
        //如果使用者所指定的題目數量超過所選單字群組內的單字數量的話，則亂數取得動作就做1次以上
        //其次數依照maxQ使用者指定出題數 除以 所選群組內單字量後結果的+1次
        for(int i=1;i<=(maxQ/tarGroup.size()+1);i++){
            rndGroup.addAll(randomizeItems(tarGroup));
        }
        String[] itemPorts;                                     //項目插槽 - 0為詞性, 1~4為答案選項
        //##依次對每一個項目做整理的動作
        for(int i=1;i<=maxQ;i++){
            //##更新項目插槽
            itemPorts = new String[5];
            //##取得單字資訊
            String[] wordinfo = MainActivity.ALL_WORDS.get(rndGroup.get(i));
            type = rnd.nextInt(5);                  //隨機取得此字中的某一詞性
            while(wordinfo[type]==null){            //判斷所選單字有沒有該詞性，如果無，則項次+1直到有為止
                type++;
                if(type==5) type=0;
            }
            ans = rnd.nextInt(4)+1;                 //從1~4中隨機選取一項(號)作為要放入答案的地方
            AnswerList.add(ans);                   //將亂數所取的答案號放入答案清單中
            itemPorts[ans] = wordinfo[type];       //將正確的中文詞性意思放入該項中
            switch(type) {                            //依照所紀錄數值來決定要放入何種詞性(字串)
                case 0:
                    itemPorts[0] = rndGroup.get(i) + " (n.)";
                    break;
                case 1:
                    itemPorts[0] = rndGroup.get(i) + " (adj.)";
                    break;
                case 2:
                    itemPorts[0] = rndGroup.get(i) + " (v.)";
                    break;
                case 3:
                    itemPorts[0] = rndGroup.get(i) + " (adv.)";
                    break;
                case 4:
                    itemPorts[0] = rndGroup.get(i) + " (prep.)";
                    break;
                default:
                    break;
            }
            //##由項目插槽的標號1做到標號4
            //設定初始亂數位置，當選擇到某一數值後，其後都會逐次往下，如: rndNum亂數取得到11，之後所要選的亂數都會是12,13,14...逐次下去的
            int rndNum = checks[type] ? (tarGroup.size()) : (MainActivity.ALL_WORDS.size());
            rndNum = rnd.nextInt(rndNum);
            String selected;            //表示由亂數所選到的英文單字
            String[] selectedWordInfo;  //表示所選到的英文單字的詞性內容
            for(int q=1 ; q<=4 ; q++) {
                /*
                                          //此部分可以簡化//
                                */
                //如果標號q內的內容為無值的話
                if(itemPorts[q]==null){
                    //確認是否要在單字群組裡隨機選取
                    if (checks[type]) {
                        //##以rndNum選擇一個單字，直到符合為止
                        do{
                            if(rndNum < tarGroup.size()-1)
                                rndNum++;
                            else
                                rndNum=0;
                            //單字群組中從取得該單字
                            selected = tarGroup.get(rndNum);
                            //取得該單字的訊息
                            selectedWordInfo = MainActivity.ALL_WORDS.get(selected);
                            //最後確認所選的單字有沒有該詞性 *並且 確認所選單字並不與目標單字相符
                        }while(selectedWordInfo[type]==null || selectedWordInfo[type].equals(itemPorts[ans]));
                        itemPorts[q] = selectedWordInfo[type];  //將亂數所選到的英文單字的指定詞性的內容放入位於 q 號的項目插槽裡
                    } else {    //從所有單字裡隨機選取
                        //##以rndNum選擇一個單字，直到符合為止
                        do{
                            rndNum++;
                            if(rndNum >= MainActivity.ALL_WORDS.size())
                                rndNum=0;
                            //單字群組中從取得該單字
                            selected = MainActivity.WORDS.get(rndNum);
                            //取得該單字的訊息
                            selectedWordInfo = MainActivity.ALL_WORDS.get(selected);
                            //最後確認所選的單字有沒有該詞性 *並且 確認所選單字並不與目標單字相符
                        }while(selectedWordInfo[type]==null || selectedWordInfo[type].equals(itemPorts[ans]));
                        itemPorts[q] = selectedWordInfo[type];  //將亂數所選到的英文單字的指定詞性的內容放入位於 q 號的項目插槽裡
                    }
                }
            }
            //將處理好的項目插槽(題目及選項)放入問題清單中
            QuestionList.add(itemPorts);
        }
    }
    //InitQuestionList ->  函式 - 回傳內容不重覆的隨機單字清單
    ArrayList<String> randomizeItems(ArrayList<String> group){
        ArrayList<String> rndGroup = (ArrayList<String>) group.clone(); //複製群組單字至rndGroup裡
        //建立亂數產生器物件
        Random rnd = new Random();
        rnd.setSeed(rnd.nextInt(100));
        //num表示由亂數所取得的整數數值;     temp表示兩變數間交換內容時的暫存處
        int num;  String temp;
        //##開始隨機排列內容：
        //作用範圍一次一次地從最大住標處做到至住標1
        //將所取的亂數放入num後，依num從rndGroup裡取出該英文單字後放入temp裡
        //然後再將rndGroup裡住標num處的英文單字覆蓋為目前範圍的最後一個英文單字(也就是在住標 i 處的英文單字)
        //最後將temp覆蓋至rndGroup裡的住標 i 處，就可完成兩變數內容交換的動作了。
        //##以上為不重複隨機排列集合內容的方法
        for(int i = rndGroup.size()-1;i>0;i--) {
            num = rnd.nextInt(i + 1);
            temp = rndGroup.get(num);
            rndGroup.set(num, rndGroup.get(i));
            rndGroup.set(i, temp);
        }
        return rndGroup;
    }

    //當btnSelection1按鈕物件按下後
    public void btnSelection1_Click(View view) {if(delay==0){answerResult(AnswerList.get(Q)==1); UserAnswerList.add(1);}}
    //當btnSelection2按鈕物件按下後
    public void btnSelection2_Click(View view) {if(delay==0){answerResult(AnswerList.get(Q)==2); UserAnswerList.add(2);}}
    //當btnSelection3按鈕物件按下後
    public void btnSelection3_Click(View view) {if(delay==0){answerResult(AnswerList.get(Q)==3); UserAnswerList.add(3);}}
    //當btnSelection4按鈕物件按下後
    public void btnSelection4_Click(View view) {if(delay==0){answerResult(AnswerList.get(Q)==4); UserAnswerList.add(4);}}

    //程序 - 使用者答錯或答對時的系統反應
    void answerResult(boolean isRight){
        rights += isRight ? 1 : 0;
        AnswerShows.setTitle(isRight ? "答對!" : "答錯!");
        AnswerShows.setMessage("答案: " + QuestionList.get(Q)[AnswerList.get(Q)]);
        AnswerShows.show();
        mode = -1;
        pgbCountdown1.setProgress(2000);
        pgbCountdown1.setMax(2000);
        timecount = 2000;
    }

    //當下層的頁面關閉時，也就是結果顯示頁面關閉時，回到此頁面後直接關閉
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        finish();
    }

    //攔截使用者所按下的按鍵 - 包含返回、家、視窗等等按鍵
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event){
        if(keyCode == KeyEvent.KEYCODE_BACK){
            if(backUpTimeCount==0){
                backUpTimeCount=2000;
                Toast.makeText(ActMultipleChoice.this, "再按一次即可離開測驗", Toast.LENGTH_SHORT).show();
            }else{
                finish();
            }
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }

    //當此頁面要關閉的時候
    @Override
    public void onDestroy(){
        countdownTimer.cancel();
        countdownTimer.purge();
        super.onDestroy();
    }
}
