package com.example.leeyuanair.englishhelper.act_allwords;

import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Toast;

import com.example.leeyuanair.englishhelper.ActSearchWord;
import com.example.leeyuanair.englishhelper.MainActivity;
import com.example.leeyuanair.englishhelper.R;

import java.util.ArrayList;
import java.util.Collections;

public class ActEditingGroup extends AppCompatActivity implements ListView.OnItemClickListener {
    //Valuable
    String groupName;                    //群組名稱
    ArrayList<String> groupArray;         //指定群組中的所有單字
    ArrayAdapter<String> arrayAdapter;
    ArrayList<Integer> Selections;
    //ListView清單物件
    ListView lstGroupWords;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_act_editing_group);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        //鏈結清單物件
        lstGroupWords = (ListView) findViewById(R.id.lstGroupWords);
        lstGroupWords.setOnItemClickListener(this);
        //初始化變數//
        Selections = new ArrayList<>();
        //讀取上一層所給的資料
        groupName = getIntent().getExtras().getString("groupName");
        setTitle("群組\"" + groupName + "\"內的所有單字");
        groupArray = MainActivity.GROUPS.get(groupName);
        if(groupArray.get(0).equals("0"))
            groupArray.remove(0);
        arrayAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_multiple_choice, groupArray);
        //將arrayAdapter鏈結至lstGroupWords
        lstGroupWords.setAdapter(arrayAdapter);
    }

    //當【返回】按鈕按下時
    public void btnBack4_Click(View view) {
        Intent newIntent = new Intent();
        if(groupArray.size()==0)
            groupArray.add("0");
        setResult(1, newIntent);
        finish();
    }

    //當【新增單字】按鈕按下時
    public void btnAddWord_Click(View view) {
        Intent theIntent = new Intent(this, ActSearchWord.class);
        theIntent.putExtra("isAddingMode", true);
        startActivityForResult(theIntent, 0);
    }
    //當【刪除單字】按鈕按下時
    public void btnRemoveWord_Click(View view) {
        if(!Selections.isEmpty()) {
            try {
                Collections.sort(Selections);
                for (int i = 0; i < arrayAdapter.getCount(); i++)
                    lstGroupWords.setItemChecked(i, false);
                for (int i = Selections.size() - 1; i >= 0; i--)
                    groupArray.remove((int) Selections.get(i));
                Selections.clear();
                arrayAdapter.notifyDataSetChanged();
            } catch (Exception ex) {
                Toast.makeText(ActEditingGroup.this, ex.toString(), Toast.LENGTH_SHORT).show();
            }
        }else{
            Toast.makeText(ActEditingGroup.this, "請選擇欲刪除的單字", Toast.LENGTH_SHORT).show();
        }
    }

    //當下一層頁面關閉後
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if(resultCode==0){
            ArrayList<String> Addition = (ArrayList<String>) data.getExtras().get("Addition");
            for(String item : Addition){
                if(!groupArray.contains(item)){
                    groupArray.add(item);
                }
            }
            Collections.sort(groupArray);
            arrayAdapter.notifyDataSetChanged();
        }
    }

    //當使用者按下清單裡某一項時
    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        try{
            if(Selections.contains(position))
                Selections.remove(Selections.indexOf(position));
            else
                Selections.add(position);
        }catch (Exception ex){
            Toast.makeText(ActEditingGroup.this, ex.toString(), Toast.LENGTH_SHORT).show();
        }
    }

    //攔截使用者所按下的按鍵 - 包含返回、家、視窗等等按鍵
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event){
        if(keyCode == KeyEvent.KEYCODE_BACK){
            Intent newIntent = new Intent();
            if(groupArray.size()==0)
                groupArray.add("0");
            setResult(1, newIntent);
            finish();
        }
        return super.onKeyDown(keyCode, event);
    }
}
