package com.example.leeyuanair.englishhelper.act_allwords;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Toast;

import com.example.leeyuanair.englishhelper.MainActivity;
import com.example.leeyuanair.englishhelper.R;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Set;

public class ActGrouping extends AppCompatActivity {
    //變數
    HashMap<String, ArrayList<String>> groups;
    //ArrayList<String> groups;        //紀錄所有Groups的名稱
    ArrayAdapter<String> arrayAdapter;
    int grpCount;
    int SelPosition;
    //ListView
    ListView lstGroups;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_act_grouping);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        setTitle("單字群組");
        //初始化變數
        groups = new HashMap<>();
        arrayAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_single_choice, MainActivity.GROUP_NAMES);
        SelPosition = -1;
        //鏈結清單元件
        lstGroups = (ListView) findViewById(R.id.lstGroups);
        lstGroups.setAdapter(arrayAdapter);
        lstGroups.setChoiceMode(ListView.CHOICE_MODE_SINGLE);
    }

    //當【返回】按鈕按下 - 返回上一層
    public void btnBack3_Click(View view) {
        try {
            OutputStream os = new FileOutputStream(getFilesDir() + "/groups.txt", false); //false -> 複寫檔案
            String saves = String.valueOf(MainActivity.groupCount);
            //束整資料 - 將資料轉換成字串的形式並儲存
            for(String key : MainActivity.GROUP_NAMES){
                saves += "\r\n" + key + "\r\n" + WordsArrayList2String(MainActivity.GROUPS.get(key));
            }
            //將資料寫入
            os.write(saves.getBytes());
            os.close();
        }catch(Exception ex){
            Toast.makeText(this, ex.toString(), Toast.LENGTH_SHORT).show();
        }
        finish();
    }
    String WordsArrayList2String(ArrayList<String> words){
        String returns = words.get(0);
        for(int i=1;i<words.size();i++){
            returns += " " + words.get(i);
        }
        return returns;
    }

    //當【新增群組】按鈕按下
    public void btnAddNewGroup_Click(View view) {
        //開啟ActAddingGroup新增群組的介面
        Intent theIntent = new Intent(this,ActAddingGroup.class);
        startActivityForResult(theIntent, 0);
    }

    //當【移除群組】按鈕按下
    public void btnRemoveGroup_Click(View view) {
        try{
            final int index = lstGroups.getCheckedItemPosition();                    //為使用者所選取的項目的駐標
            final String groupName = lstGroups.getItemAtPosition(index).toString(); //為使用者所選取的群組名稱
            //若使用者有選取項目(群組)，即index大於-1時
            if (index>-1){
                //生成一個對話方塊來再次確認是否刪除
                AlertDialog.Builder ad = new AlertDialog.Builder(this);
                //設定對話方塊的標題為"確認刪除"
                ad.setTitle("確認刪除");
                //設定對話方塊的內容為"確定要刪除群組"[群組名稱]"?"
                ad.setMessage("確定要刪除群組\"" + lstGroups.getItemAtPosition(lstGroups.getCheckedItemPosition()) + "\"?");
                //設定當使用者按下對話方塊的正回應按鍵，也就是按下"確定"按鈕時的事件。
                //若使用者按下【確定】，以指定所選的項目，把groups裡的群組名稱與群組內容、arrayAdapter裡的群組名稱刪除。
                ad.setPositiveButton("確定", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        try {
                            MainActivity.GROUPS.remove(groupName);
                            MainActivity.GROUP_NAMES.remove(index);
                            MainActivity.groupCount--;
                            arrayAdapter.notifyDataSetChanged();
                            lstGroups.setSelection(-1);
                        } catch (Exception ex) {
                            Toast.makeText(ActGrouping.this, ex.toString(), Toast.LENGTH_SHORT).show();
                        }
                    }
                });
                //設定當使用者按下對話方塊的負回應按鍵，也就是按下"取消"按鈕時的事件。
                ad.setNegativeButton("取消", new DialogInterface.OnClickListener() {@Override public void onClick(DialogInterface dialog, int which) {}});
                //顯示對話方塊
                ad.show();
            }
        }catch (Exception ex){
            if(ex.getClass().getSimpleName().equals("NullPointerException"))
                Toast.makeText(this, "請選擇欲刪除的群組", Toast.LENGTH_SHORT).show();
            else
                Toast.makeText(ActGrouping.this, ex.toString(), Toast.LENGTH_SHORT).show();
        }
    }

    //當【編輯群組單字】按鈕按下
    public void btnViewGroupWords_Click(View view) {
        try{
            String groupName = lstGroups.getItemAtPosition(lstGroups.getCheckedItemPosition()).toString();
            Intent theIntent = new Intent(this, ActEditingGroup.class);
            theIntent.putExtra("groupName", groupName);
            startActivityForResult(theIntent, 1);
        }catch(Exception ex){
            if(ex.getClass().getSimpleName().equals("NullPointerException"))
                Toast.makeText(this, "請選擇欲編輯的群組", Toast.LENGTH_SHORT).show();
            else
                Toast.makeText(ActGrouping.this, ex.toString(), Toast.LENGTH_SHORT).show();
        }
    }

    //當下一層的版面關閉後
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
       switch (resultCode){
           case 0:
               String theName = data.getStringExtra("NewGroupName");
               if(!theName.equals("$NONE")){
                   try{
                       ArrayList<String> newArrayList = new ArrayList<>(); newArrayList.add("0");
                       MainActivity.GROUPS.put(theName, newArrayList);
                       MainActivity.GROUP_NAMES.add(theName);
                       MainActivity.groupCount++;
                       arrayAdapter.notifyDataSetChanged();
                   }catch(Exception ex) {
                       Toast.makeText(this, ex.toString(), Toast.LENGTH_SHORT).show();
                   }
               }
               break;
           case 1:
               //ArrayList<String> groupArray = (ArrayList<String>) data.getExtras().get("groupArray");
               //String groupName = data.getExtras().getString("groupName");
               //groups.put(groupName, groupArray);
               break;
       }
    }

    //Keeps
    void keeps(){

    }
}
