package com.example.leeyuanair.englishhelper.act_allwords;

import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.content.res.AssetManager;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.Toast;

import com.example.leeyuanair.englishhelper.R;
import com.example.leeyuanair.englishhelper.access.WordInfo;

import java.io.InputStream;
import java.util.ArrayList;

public class ActPieceVoca extends AppCompatActivity implements AdapterView.OnItemClickListener {
    ArrayList<String> WordsList;
    ArrayAdapter<String> arrayAdapter;
    //WordsData
    WordInfo[] words;
    //Button
    Button btnBack;
    //ListView
    ListView lstWords;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_act_piece_voca);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        //從Intent中解析Bundle
        Bundle msg = getIntent().getExtras();
        //鏈結按鈕物件
        btnBack = (Button) findViewById(R.id.btnBack1);
        //鏈結清單物件
        lstWords = (ListView) findViewById(R.id.lstWords1);
        lstWords.setOnItemClickListener(this);
        //設定基本清單數值
        WordsList = new ArrayList<String>();
        arrayAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1,WordsList);
        //取得於畫面ActAllVaco的lstWords裡所選擇項目，並依照該值取得相符的自首單字。
        String SelectedLetter = msg.getString("SelectedItem");
        readAppointedVoca(SelectedLetter);
        setTitle("字首為\""+SelectedLetter+"\"的所有單字");
    }

    //程序: 讀取指定字首的單字，並設定至ListView。
    protected void readAppointedVoca(String letter){
        AssetManager as = getAssets();
        try{
            InputStream is = as.open("Words.txt");
            byte[] data = new byte[is.available()];
            is.read(data); is.close();
            WordsList.addAll(getAppointedVoca(new String(data),letter.toLowerCase()));
            arrayAdapter.notifyDataSetChanged();
            lstWords.setAdapter(arrayAdapter);
        }catch(Exception ex){
            Toast.makeText(this,ex.toString(),Toast.LENGTH_SHORT).show();
        }
    }
    //函式: 取得指定字首的字(解析字串)，並回傳所選到的字。
    protected ArrayList<String> getAppointedVoca(String data,String targe){
        ArrayList<String> returns = new ArrayList<String>();
        String[] info = (data.replace("\r","")).split("\n");
        String[] spis;
        for(int i = 1; i<info.length;i++){
            spis = info[i].split(" ");
            if(spis[0].indexOf(targe)==0){
                returns.add(spis[0]);
            }
        }
        return returns;
    }
    //當【返回】按鈕按下時，返回到上一層。
    public void btnBack1_onClick(View view) {
        finish();
    }
    //處理清單按下某一項目時所處理的動作。即顯示使用者所選取的單字。
    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        Object SelItem = parent.getItemAtPosition(position);
        Intent theIntent = new Intent(this,ActWordInfo.class);
        theIntent.putExtra("SelectedWord", SelItem.toString());
        theIntent.putExtra("isAddingMode", false);
        //theIntent.putExtra("WordsData",words);
        startActivity(theIntent);
    }
}
