package com.example.leeyuanair.englishhelper.act_allwords;

import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.content.res.AssetManager;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.LinearLayout;
import android.view.ViewGroup.LayoutParams;
import android.widget.TextView;
import android.widget.Toast;

import com.example.leeyuanair.englishhelper.MainActivity;
import com.example.leeyuanair.englishhelper.R;

import java.io.InputStream;

public class ActWordInfo extends AppCompatActivity {
    //Global Variables
    boolean isAddingMode;
    String isAdd;
    //LinearLayout直式排版元件
    LinearLayout linNoun, linAdjective, linVerb, linAdverb, linPreposition;
    //TextView文字標籤元件
    TextView lblWordTitle, lblNoun, lblAdjective, lblVerb, lblAdverb, lblPreposition;
    //Button按鈕元件
    Button btnAdd2Addition;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_act_word_info);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        //取得傳遞的訊息
        Bundle msg = getIntent().getExtras();
        //鏈結橫列表格物件
        linNoun = (LinearLayout) findViewById(R.id.linNoun);
        linAdjective = (LinearLayout) findViewById(R.id.linAdjective);
        linVerb = (LinearLayout) findViewById(R.id.linVerb);
        linAdverb = (LinearLayout) findViewById(R.id.linAdverb);
        linPreposition = (LinearLayout) findViewById(R.id.linPreposition);
        //鏈結標籤物件
        lblWordTitle = (TextView) findViewById(R.id.lblWordTitle);
        lblNoun = (TextView) findViewById(R.id.lblNoun);
        lblAdjective = (TextView) findViewById(R.id.lblAdjective);
        lblVerb = (TextView) findViewById(R.id.lblVerb);
        lblAdverb = (TextView) findViewById(R.id.lblAdverb);
        lblPreposition = (TextView) findViewById(R.id.lblPreposition);
        //鏈結按鈕物件
        btnAdd2Addition = (Button) findViewById(R.id.btnAdd2Addition);
        //判斷是否有選擇單字的功能
        isAddingMode = (boolean) msg.get("isAddingMode");
        LayoutParams btnLayout = btnAdd2Addition.getLayoutParams();
        btnLayout.height = isAddingMode ? btnLayout.height : 0;
        btnAdd2Addition.setLayoutParams(btnLayout);
        btnAdd2Addition.setEnabled(isAddingMode);
        //初始化是否新增該單字的暫存，原設為無值null
        isAdd = null;
        //取得所選單字
        String SelectedWord = msg.getString("SelectedWord");
        setTitle("單字\""+SelectedWord+"\"的詞性、字義");
        //取得該單字的詞性與字義
        try{
            lblWordTitle.setText(SelectedWord);
            String[] pOS = MainActivity.ALL_WORDS.get(SelectedWord);
            lblNoun.setText((pOS[0]!=null && !pOS[0].equals("")) ? pOS[0] : "");
            lblAdjective.setText((pOS[1]!=null && !pOS[1].equals("")) ? pOS[1] : "");
            lblVerb.setText((pOS[2]!=null && !pOS[2].equals("")) ? pOS[2] : "");
            lblAdverb.setText((pOS[3]!=null && !pOS[3].equals("")) ? pOS[3] : "");
            lblPreposition.setText((pOS[4]!=null && !pOS[4].equals("")) ? pOS[4] : "");
            //找到使用者所選的單字時，解析該訊息並顯示詞性、字義
            hideLayout(lblNoun.getText().equals(""), linNoun);
            hideLayout(lblAdjective.getText().equals(""),linAdjective);
            hideLayout(lblVerb.getText().equals(""),linVerb);
            hideLayout(lblAdverb.getText().equals(""),linAdverb);
            hideLayout(lblPreposition.getText().equals(""),linPreposition);
        }catch(Exception ex) {
            Toast.makeText(this,"找不到該單字!",Toast.LENGTH_SHORT).show();
        }
    }
    //影藏Layout的判斷函式
    public void hideLayout(boolean compare,LinearLayout ly){
        if(compare){
            ViewGroup.LayoutParams lay = ly.getLayoutParams();
            lay.height = 0;
            ly.setLayoutParams(lay);
        }
    }

    //返回上一層
    public void btnBack2_onClick(View view) {
        Intent theIntent = new Intent();
        if(isAddingMode){
            theIntent.putExtra("isAdd", isAdd);
        }
        setResult(isAddingMode ? 0 : -1, theIntent);
        finish();
    }

    //標示使用者要增加此單字
    public void btnAdd2Addition(View view) {
        isAdd = lblWordTitle.getText().toString();
        Toast.makeText(ActWordInfo.this, "已新增單字至群組", Toast.LENGTH_SHORT).show();
    }

    //攔截使用者所按下的按鍵 - 包含返回、家、視窗等等按鍵
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event){
        if(keyCode == KeyEvent.KEYCODE_BACK){
            Intent theIntent = new Intent();
            if(isAddingMode){
                theIntent.putExtra("isAdd", isAdd);
            }
            setResult(isAddingMode ? 0 : -1, theIntent);
            finish();
        }
        return super.onKeyDown(keyCode, event);
    }
}
