package com.example.leeyuanair.englishhelper.act_memory;

import android.app.AlertDialog;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;

import com.example.leeyuanair.englishhelper.MainActivity;
import com.example.leeyuanair.englishhelper.R;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.Random;
import java.util.Timer;
import java.util.TimerTask;

public class ActMemoryPractice extends AppCompatActivity {
    //##Global Variable
    boolean mode;                       //練習模式: false表示有限題數, true表示練習至了解為止
    int groupIndex;                      //使用者所選的群組單字的序號
    int maxQ, Q;                        //表示指定的練習題數 與 目前題數
    int timelimit;                        //每題所限制的回答時間(毫秒)
    int timecount;                       //目前的計時
    int delay;                           //延遲次數(每次1秒)
    int width;                           //表示加上timecount的幅度，功能是與timecount相加
    int backUpTimeCount;               //退出練習的確認時間
    ArrayList<String> QuestionList;     //題目清單
    LinkedHashMap<String, Integer> WrongsList;  //「NO」清單，記錄下所有不了解的單字的次數
    HashSet<String> QuickWrongsList;         //與「NO」清單類似，只不過此清單只有在「練習至了解所有單字為止」時的模式才會用到
    //TextView文字標籤物件
    TextView lblMemoryStatus, lblQuestion1, lblMemoryHint;
    //ProgressBar進度顯示物件
    ProgressBar pgbCountdown2;
    //Timer計時器
    Timer countDownTimer;
    //AlertDialog對話框物件
    AlertDialog answerShows;
    //Random亂數產生器
    Random rnd;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_act_memory_practice);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        setTitle("記憶練習");
            //連結文字標籤物件
            lblMemoryStatus = (TextView) findViewById(R.id.lblMemoryStatus);
            lblQuestion1 = (TextView) findViewById(R.id.lblQuestion1);
            lblMemoryHint = (TextView) findViewById(R.id.lblMemoryHint);
            //連結進度顯示物件
            pgbCountdown2 = (ProgressBar) findViewById(R.id.pgbCountdown2);
            pgbCountdown2.setMax(1000);
            //初始化對話方塊
            answerShows = (new AlertDialog.Builder(this)).create();
            answerShows.setCancelable(false);
            //初始化NO清單
            WrongsList = new LinkedHashMap<>();
            //初始化亂數產生器
            rnd = new Random();
            //取得資料 & 初始化
            Bundle msg = getIntent().getExtras();
            mode = msg.getBoolean("mode");
            timelimit = msg.getInt("timelimit");
            groupIndex = msg.getInt("Selection");
            //若模式為練習到了解為止..
            if (mode) {
                QuestionGenerator(1);
                QuickWrongsList = new HashSet<>();
            } else {
                maxQ = msg.getInt("questions");
                QuestionGenerator(maxQ);
            }
            Q = 0;            //初始化題目計數
            timecount = 0;    //初始化計時
            delay = 4;        //初始化延遲次數
            width = 1;
            //初始化計時系統Timer
            countDownTimer = new Timer();
            countDownTimer.schedule(countDownTask, 0, 1);
    }

    //####題目生成器####
    void QuestionGenerator(int questionAmount){
        try {
            ArrayList<String> sourceGroup = ((groupIndex >= 0) ? MainActivity.GROUPS.get(MainActivity.GROUP_NAMES.get(groupIndex)) : MainActivity.WORDS);
            QuestionList = new ArrayList<String>();
            for (int i = 1; i <= (questionAmount / sourceGroup.size()) + 1; i++)
                QuestionList.addAll(RandomizeList(sourceGroup));
        }catch(Exception ex){
            Toast.makeText(ActMemoryPractice.this, ex.toString(), Toast.LENGTH_SHORT).show();
        }
    }
    //函式 - 回傳新的已打亂過的清單內容
    ArrayList<String> RandomizeList(ArrayList<String> list) {
        ArrayList<String> rndList = (ArrayList<String>) list.clone();
        try {
            String temp;
            int num;
            //利用rnd亂數產生器打亂原本的排列
            for (int i = rndList.size() - 1; i >= 0; i--) {
                num = rnd.nextInt(i + 1);
                temp = rndList.get(num);
                rndList.set(num, rndList.get(i));
                rndList.set(i, temp);
            }
        } catch (Exception ex) {
            Toast.makeText(ActMemoryPractice.this, ex.toString(), Toast.LENGTH_SHORT).show();
        }
        return rndList;
    }
    //####快速題目生產器####
    void RapidQuestionGenerator(String word ,int value){
        if(!QuestionList.contains(word)){
            ArrayList<String> sourceGroup = ((groupIndex>=0) ? MainActivity.GROUPS.get(MainActivity.GROUP_NAMES.get(groupIndex)) : MainActivity.WORDS);
            ArrayList<String> rndList = new ArrayList<>(RandomizeList(sourceGroup));
            //若使用者所選的單字群組的單字量小於10: 為了避免在隨機選取的次數上發生問題，也就是隨機排列後的群組單字量不夠，這裡再增加一組的隨機的單字量
            if(sourceGroup.size()<10)
                rndList.addAll(RandomizeList(sourceGroup));
            for(int i=0;i<rndList.size();i++){
                if(!rndList.get(i).equals(word)){
                    QuestionList.add(rndList.get(i));
                    value--;
                    if(value==0)break;
                }
            }
            QuestionList.add(word);
        }
    }

    //####計時器工作####
    private final TimerTask countDownTask = new TimerTask() {
        @Override
        public void run() {
            //####透過runOnUiThread來取得合法控制使用者介面物件的權利####
            runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    timecount += width;
                    //若已不再延遲的狀態...
                    if (delay == 0) {
                        //如果判別目前的狀態是作答中還是答案顯示中
                        //width為1時代表作答中, width為-1代表答案顯示中
                        if (width == 1) {
                            //如果時間到的話(對此視為NO)
                            if (timecount == timelimit) {
                                //判別使用者所選的模式
                                if (mode) {
                                    //判別NO清單裡是否有包含該單字，如果沒有包含就新增一個；如果已經包含了就增加其數值
                                    if (WrongsList.containsKey(QuestionList.get(0))) {
                                        //取出目前的題目當作key，並設其value為原先的數值+1
                                        WrongsList.put(QuestionList.get(0), WrongsList.get(QuestionList.get(0)) + 1);
                                    } else {
                                        WrongsList.put(QuestionList.get(0), 1);
                                    }
                                    QuickWrongsList.add(QuestionList.get(0));
                                    pgbCountdown2.setMax(5000);
                                    timecount=5000;
                                    width = -1;
                                    answerShows.setTitle("超過時間!");
                                    //解析該字有哪些詞性與意思，並設定於將要顯示的對話框上
                                    String[] partOfSpeech = MainActivity.ALL_WORDS.get(QuestionList.get(0));
                                    answerShows.setMessage(QuestionList.get(0) +
                                            ((partOfSpeech[0] != null) ? "\r\n" + "名詞(n.) " + partOfSpeech[0] : "") +
                                            ((partOfSpeech[1] != null) ? "\r\n" + "形容詞(adj.) " + partOfSpeech[1] : "") +
                                            ((partOfSpeech[2] != null) ? "\r\n" + "動詞(v.) " + partOfSpeech[2] : "") +
                                            ((partOfSpeech[3] != null) ? "\r\n" + "副詞(adv.) " + partOfSpeech[3] : "") +
                                            ((partOfSpeech[4] != null) ? "\r\n" + "介係詞(prep.) " + partOfSpeech[4] : ""));
                                    answerShows.show();
                                    String readdWord = QuestionList.remove(0);
                                    RapidQuestionGenerator(readdWord, rnd.nextInt(3) + 2);
                                } else {
                                    //判別NO清單裡是否有包含該單字，如果沒有包含就新增一個；如果已經包含了就增加其數值
                                    if (WrongsList.containsKey(QuestionList.get(Q))) {
                                        //取出目前的題目當作key，並設其value為原先的數值+1
                                        WrongsList.put(QuestionList.get(Q), WrongsList.get(QuestionList.get(Q)) + 1);
                                    } else {
                                        WrongsList.put(QuestionList.get(Q), 1);
                                    }
                                    pgbCountdown2.setMax(5000);
                                    timecount=5000;
                                    width = -1;
                                    answerShows.setTitle("超過時間!");
                                    //解析該字有哪些詞性與意思，並設定於將要顯示的對話框上
                                    String[] partOfSpeech = MainActivity.ALL_WORDS.get(QuestionList.get(Q));
                                    answerShows.setMessage("請熟記此單字: " + QuestionList.get(Q) +
                                            ((partOfSpeech[0] != null) ? "\r\n" + "名詞(n.) " + partOfSpeech[0] : "") +
                                            ((partOfSpeech[1] != null) ? "\r\n" + "形容詞(adj.) " + partOfSpeech[1] : "") +
                                            ((partOfSpeech[2] != null) ? "\r\n" + "動詞(v.) " + partOfSpeech[2] : "") +
                                            ((partOfSpeech[3] != null) ? "\r\n" + "副詞(adv.) " + partOfSpeech[3] : "") +
                                            ((partOfSpeech[4] != null) ? "\r\n" + "介係詞(prep.) " + partOfSpeech[4] : ""));
                                    answerShows.show();
                                }
                            }
                        } else if (width == -1) {
                            //若倒數完畢
                            if (timecount == 0) {
                                //判別使用者所選的模式
                                Q++;                                    //題目計數+1
                                answerShows.dismiss();                  //隱藏對話框
                                if (mode) {
                                    //判別題目是否做完了
                                    if (QuestionList.isEmpty() && QuickWrongsList.isEmpty()) {
                                        //##若題目已經做完了，則傳送紀錄並開啟結果頁面
                                        //停止計時器計時，並且停用該物件
                                        countDownTimer.cancel();
                                        countDownTimer.purge();
                                        //設置紀錄並開啟結果頁面
                                        Intent it = new Intent(ActMemoryPractice.this, ActMemoryResult.class);
                                        it.putExtra("mode", mode);
                                        it.putExtra("questions", Q);
                                        it.putExtra("WrongsList", WrongsList);
                                        startActivityForResult(it, 0);
                                    } else {
                                        lblQuestion1.setText(QuestionList.get(0));
                                        lblMemoryStatus.setText("目前題數: "+(Q+1));
                                        makeHint(QuestionList.get(0));
                                        if (timelimit == 0) {
                                            //如果時間無限制的話，就不需要在增加進度顯示物件的進度量
                                            //因此這裡pgbCountdown2的最大值設定為一定值
                                            //並且把變化量width設為0
                                            pgbCountdown2.setMax(500);
                                            timecount=1;
                                            width = 0;
                                        } else {
                                            pgbCountdown2.setMax(timelimit);
                                            width = 1;
                                        }
                                    }
                                } else {
                                    //判別題目是否尚未做完
                                    if (Q < maxQ) {
                                        //更新題目
                                        lblQuestion1.setText(QuestionList.get(Q));
                                        lblMemoryStatus.setText("剩餘題數: "+(maxQ-Q-1));
                                        makeHint(QuestionList.get(Q));
                                        //判別時間限制是否為0，也就是判斷使用者是否將時限設定為「無限制」
                                        if (timelimit == 0) {
                                            //如果時間無限制的話，就不需要在增加進度顯示物件的進度量
                                            //因此這裡pgbCountdown2的最大值設定為一定值
                                            //並且把變化量width設為0
                                            pgbCountdown2.setMax(500);
                                            timecount=1;
                                            width = 0;
                                        } else {
                                            pgbCountdown2.setMax(timelimit);
                                            width = 1;
                                        }
                                    } else {
                                        //##若題目已經做完了，則傳送紀錄並開啟結果頁面
                                        //停止計時器計時，並且停用該物件
                                        countDownTimer.cancel();
                                        countDownTimer.purge();
                                        //設置紀錄並開啟結果頁面
                                        Intent it = new Intent(ActMemoryPractice.this, ActMemoryResult.class);
                                        it.putExtra("mode", mode);
                                        it.putExtra("questions", maxQ);
                                        it.putExtra("WrongsList", WrongsList);
                                        startActivityForResult(it, 0);
                                    }
                                }
                            }
                        }
                    } else {
                        if (timecount == 1000) {
                            delay--;
                            timecount = 0;
                            lblQuestion1.setText(String.valueOf(delay));
                            if (delay == 0) {
                                if (timelimit == 0){
                                    width = 0;
                                    timecount=1;
                                }
                                lblQuestion1.setText(QuestionList.get(0));
                                makeHint(QuestionList.get(0));
                                pgbCountdown2.setMax(timelimit);
                                if(mode)
                                    lblMemoryStatus.setText("目前題數: "+(Q+1));
                                else
                                    lblMemoryStatus.setText("剩餘題數: "+(maxQ-Q-1));

                            }
                        }
                    }
                    //更新進度顯示物件
                    pgbCountdown2.setProgress(timecount);
                }
            });
        }
    };
    //程序 - 解析單字訊息 並 提示其有哪一些詞性
    void makeHint(String word){
        String[] partOfSpeech = MainActivity.ALL_WORDS.get(word);
        lblMemoryHint.setText("這個單字有" + (partOfSpeech[0] != null ? " #名詞" : "") +
                (partOfSpeech[1] != null ? " #形容詞" : "") +
                (partOfSpeech[2] != null ? " #動詞" : "") +
                (partOfSpeech[3] != null ? " #副詞" : "") +
                (partOfSpeech[4] != null ? " #介係詞" : "") + " 詞性意思\r\n你清楚此單字的意思嗎?");
    }

    //當【NO】按鈕按下時
    public void btnNO_Click(View view) {
        if(delay==0) {
            int Qnum = mode ? 0 : Q;
            //判別NO清單裡是否有包含該單字，如果沒有包含就新增一個；如果已經包含了就增加其數值
            if (WrongsList.containsKey(QuestionList.get(Qnum))) {
                //取出目前的題目當作key，並設其value為原先的數值+1
                WrongsList.put(QuestionList.get(Qnum), WrongsList.get(QuestionList.get(Qnum)) + 1);
            } else {
                WrongsList.put(QuestionList.get(Qnum), 1);
            }
            pgbCountdown2.setMax(5000);
            pgbCountdown2.setProgress(5000);
            timecount = 5000;
            width = -1;
            answerShows.setTitle("我不了解單字\"" + QuestionList.get(Qnum) + "\"!");
            //解析該字有哪些詞性與意思，並設定於將要顯示的對話框上
            String[] partOfSpeech = MainActivity.ALL_WORDS.get(QuestionList.get(Qnum));
            answerShows.setMessage("請熟記此單字: " + QuestionList.get(Qnum) +
                    ((partOfSpeech[0] != null) ? "\r\n" + "名詞(n.) " + partOfSpeech[0] : "") +
                    ((partOfSpeech[1] != null) ? "\r\n" + "形容詞(adj.) " + partOfSpeech[1] : "") +
                    ((partOfSpeech[2] != null) ? "\r\n" + "動詞(v.) " + partOfSpeech[2] : "") +
                    ((partOfSpeech[3] != null) ? "\r\n" + "副詞(adv.) " + partOfSpeech[3] : "") +
                    ((partOfSpeech[4] != null) ? "\r\n" + "介係詞(prep.) " + partOfSpeech[4] : ""));
            answerShows.show();
            if (mode) {
                QuickWrongsList.add(QuestionList.get(0));
                String readdWord = QuestionList.remove(0);
                RapidQuestionGenerator(readdWord, rnd.nextInt(3) + 2);
            }
        }
    }

    //當【YES】按鈕按下時
    public void btnYES_Click(View view) {
        if(delay==0) {
            int Qnum = mode ? 0 : Q;            //依mode來判斷題目序號是0或是計算中的Q
            pgbCountdown2.setMax(1000);
            pgbCountdown2.setProgress(1000);
            timecount = 1000;
            width = -1;
            answerShows.setTitle("Good Job!");
            String[] partOfSpeech = MainActivity.ALL_WORDS.get(QuestionList.get(Qnum));
            answerShows.setMessage(QuestionList.get(Qnum) +
                    ((partOfSpeech[0] != null) ? "\r\n" + "名詞(n.) " + partOfSpeech[0] : "") +
                    ((partOfSpeech[1] != null) ? "\r\n" + "形容詞(adj.) " + partOfSpeech[1] : "") +
                    ((partOfSpeech[2] != null) ? "\r\n" + "動詞(v.) " + partOfSpeech[2] : "") +
                    ((partOfSpeech[3] != null) ? "\r\n" + "副詞(adv.) " + partOfSpeech[3] : "") +
                    ((partOfSpeech[4] != null) ? "\r\n" + "介係詞(prep.) " + partOfSpeech[4] : ""));
            answerShows.show();
            if (mode) {
                QuickWrongsList.remove(QuestionList.get(0));
                QuestionList.remove(0);
            }
        }
    }

    //攔截使用者所按下的按鍵 - 包含返回、家、視窗等等按鍵
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event){
        if(keyCode == KeyEvent.KEYCODE_BACK){
            if(backUpTimeCount==0){
                backUpTimeCount=2000;
                Toast.makeText(ActMemoryPractice.this, "再按一次即可離開測驗", Toast.LENGTH_SHORT).show();
            }else{
                finish();
            }
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }

    //當下層的頁面關閉時，也就是結果顯示頁面關閉時，回到此頁面後直接關閉
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        finish();
    }

    //當此頁面要關閉的時候
    @Override
    public void onDestroy(){
        countDownTimer.cancel();
        countDownTimer.purge();
        super.onDestroy();
    }
}
