package com.example.leeyuanair.englishhelper.act_memory;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.pm.ActivityInfo;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.example.leeyuanair.englishhelper.MainActivity;
import com.example.leeyuanair.englishhelper.R;

import java.util.HashMap;

public class ActMemoryResult extends AppCompatActivity implements ListView.OnItemClickListener {
    //Global Variable
    int questions;
    HashMap<String, Integer> WrongsList;
    Object[] WrongsWordsArray;
    ArrayAdapter<String> WrongsAdapter;
    //TextView文字標籤物件
    TextView lblQuestionAmount2;
    TextView lblNotUnderstandText1;
    //ListView清單物件
    ListView lstNotUnderstandList;
    //AlertDialog對話框物件
    AlertDialog.Builder msgBox;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_act_memory_result);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        setTitle("記憶練習 - 練習結果");
        try {
            //連結文字標籤物件
            lblQuestionAmount2 = (TextView) findViewById(R.id.lblQuestionAmount2);
            lblNotUnderstandText1 = (TextView) findViewById(R.id.lblNotUnderstandText1);
            //連結清單物件
            lstNotUnderstandList = (ListView) findViewById(R.id.lstNotUnderstandList);
            lstNotUnderstandList.setOnItemClickListener(this);
            //初始化對話框物件
            msgBox = new AlertDialog.Builder(this);
            msgBox.setTitle("單字訊息");
            msgBox.setPositiveButton("OK", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {
                }
            });
            //取得結果資料
            Bundle msg = getIntent().getExtras();
            questions = msg.getInt("questions");
            lblQuestionAmount2.setText(String.valueOf(questions));
            WrongsList = (HashMap<String, Integer>) msg.get("WrongsList");
            //初始化清單物件變數
            if(WrongsList.isEmpty()){
                lblNotUnderstandText1.setText("Good Job! 你已經記起所有的單字了!");
            }else{
                WrongsAdapter = new ArrayAdapter<>(this, android.R.layout.simple_list_item_1);
                WrongsWordsArray = WrongsList.keySet().toArray();
                for (Object word : WrongsWordsArray)
                    WrongsAdapter.add(word.toString() + " ,次數: " + WrongsList.get(word));
                lstNotUnderstandList.setAdapter(WrongsAdapter);
            }
        }catch(Exception ex){
            Toast.makeText(ActMemoryResult.this, ex.toString(), Toast.LENGTH_SHORT).show();
        }
    }

    //當清單lstWrongsList某項目被按下時
    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        String[] partOfSpeech = MainActivity.ALL_WORDS.get(WrongsWordsArray[position]);
        msgBox.setMessage(WrongsWordsArray[position] +
                ((partOfSpeech[0]!=null) ? "\r\n名詞(n.) "+partOfSpeech[0] : "") +
                ((partOfSpeech[1]!=null) ? "\r\n形容詞(adj.) "+partOfSpeech[1] : "") +
                ((partOfSpeech[2]!=null) ? "\r\n動詞(adj.) "+partOfSpeech[2] : "") +
                ((partOfSpeech[3]!=null) ? "\r\n副詞(adj.) "+partOfSpeech[3] : "") +
                ((partOfSpeech[4]!=null) ? "\r\n介係詞(adj.) "+partOfSpeech[4] : ""));
        msgBox.show();
    }

    //當【返回至設定頁面】按鈕按下時
    public void btnBack7_Click(View view) {finish();}

}
