package com.example.leeyuanair.englishhelper.act_memory;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.graphics.Color;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.SeekBar;
import android.widget.TextView;

import com.example.leeyuanair.englishhelper.MainActivity;
import com.example.leeyuanair.englishhelper.R;

import java.util.ArrayList;

public class ActMemorySetting extends AppCompatActivity implements SeekBar.OnSeekBarChangeListener {
    //Global Variable全域變數
    boolean qualified;      //表示所選群組是否符合最低要求(單字量>4)
    int selection;           //表示使用者所選擇的群組號
    boolean soManyWordsNotice;  // 若是用者在了解模式下選擇超過100個單字的單字群組時所判別是否要提醒使用者的變數
    //Button按鈕物件
    Button btnChangeGroup2;
    //EditText文字編輯物件
    EditText txtQAmount2;
    //TextView文字標籤物件
    TextView lblTimePerQ2;
    TextView lblExtraMsg2;
    //RadioButton單選按鈕物件
    RadioButton rdoKeepPractice, rdoQuestions;
    //SeekBar滑桿元件
    SeekBar skbTimeSet2;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_act_memory_setting);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        setTitle("記憶練習");
        //連結按鈕物件
        btnChangeGroup2 = (Button) findViewById(R.id.btnChangeGroup2);
        //連結文字編輯物件
        txtQAmount2 = (EditText) findViewById(R.id.txtQAmount2);
        //連結文字標籤物驗
        lblTimePerQ2 = (TextView) findViewById(R.id.lblTimePerQ2);
        lblExtraMsg2 = (TextView) findViewById(R.id.lblExtraMsg2);
        //連結單選按鈕物件
        rdoKeepPractice = (RadioButton) findViewById(R.id.rdoKeepPractice);
        rdoQuestions = (RadioButton) findViewById(R.id.rdoQuestions);
        //連結華感物件
        skbTimeSet2 = (SeekBar) findViewById(R.id.skbTimeSet2);
        skbTimeSet2.setOnSeekBarChangeListener(this);
        //初始化變數
        qualified=true;
        soManyWordsNotice = true;
        selection=-1;
    }

    //當按鈕btnChangeGroup2 更換群組按鈕按下時
    public void btnChangeGroup2_Click(View view) {
        final ArrayAdapter<String> groupNames = new ArrayAdapter<String>(this,android.R.layout.simple_list_item_1);
        groupNames.add("所有單字"); groupNames.addAll(MainActivity.GROUP_NAMES);
        AlertDialog.Builder msgBox = new AlertDialog.Builder(this)
                .setTitle("選擇群組")
                .setAdapter(groupNames, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        btnChangeGroup2.setText(groupNames.getItem(which));
                        selection=which-1;
                        if(which>0){
                            ArrayList<String> SelGroup = MainActivity.GROUPS.get(groupNames.getItem(which));
                            if(SelGroup.size()<4) {
                                lblExtraMsg2.setText("群組內的單字量必須大於4個才能開始練習!");
                                lblExtraMsg2.setTextColor(Color.RED);
                                soManyWordsNotice=false;
                                qualified = false;
                            }else if(SelGroup.size()>100){
                                if(rdoKeepPractice.isChecked())
                                    lblExtraMsg2.setText("此單字群組的單字量大於100個，若要練習到完可能需要花較長的時間!");
                                else
                                    lblExtraMsg2.setText("");
                                qualified=true;
                                soManyWordsNotice=true;
                            }else{
                                lblExtraMsg2.setText("");
                                qualified = true;
                                soManyWordsNotice=false;
                            }
                        }else{
                            if(rdoKeepPractice.isChecked())
                                lblExtraMsg2.setText("此單字群組的單字量大於100個，若要練習到完可能需要花較長的時間!");
                            soManyWordsNotice=true;
                            lblExtraMsg2.setText("");
                            qualified = true;
                        }
                    }
                });
        msgBox.show();
    }

    //當【-】按鈕按下時
    public void btnSubtract2_Click(View view) {
        int num = Integer.parseInt(txtQAmount2.getText().toString()) - 1;
        txtQAmount2.setText(String.valueOf(num > 0 ? num : 1));
    }

    //當【+】按鈕按下時
    public void btnAdd2_Click(View view) {
        int num = Integer.parseInt(txtQAmount2.getText().toString()) + 1;
        txtQAmount2.setText(String.valueOf(num < 10000 ? num : 9999));
    }

    //當【練習到每個單字了解為止】單選按鈕按下時
    public void rdoKeepPractice_Click(View view) {
        rdoKeepPractice.setChecked(true);
        rdoQuestions.setChecked(false);
        if(soManyWordsNotice)
            lblExtraMsg2.setText("此單字群組的單字量大於100個，若要練習到完可能需要花較長的時間!");
    }

    //當【依指定題數練習】單選按鈕按下時
    public void rdoQuestions_Click(View view) {
        rdoKeepPractice.setChecked(false);
        rdoQuestions.setChecked(true);
        if(soManyWordsNotice)
            lblExtraMsg2.setText("");
    }

    //當【返回】按鈕按下時
    public void btnBack6_Click(View view) {
        finish();
    }

    //當【說明】按鈕按下時
    public void btnExplanation2_Click(View view) {
        final AlertDialog.Builder adExp1, adExp2, adExp3;
        adExp3 = new AlertDialog.Builder(this)
                .setTitle("說明")
                .setMessage("關於設定的部分，你可以選擇單字群組、設定題目數量與每題答題時間，" +
                            "練習模式可以選擇「練習到每個了解為止」、「依指定題數練習」這兩種方式。" +
                            "完成設定之後就可以開始練習了!")
                .setPositiveButton("OK", new DialogInterface.OnClickListener() {@Override public void onClick(DialogInterface dialog, int which) {}});
        adExp2 = new AlertDialog.Builder(this)
                .setTitle("說明")
                .setMessage("如果知道該單字的意思的話，按下YES按鈕表示了解；若不知道該單字的意思，" +
                            "則按下NO表示不了解，每按一次NO系統就會記錄下一次。如果你所選的模式是練習到會為止，" +
                            "則系統也會一直持續記錄到完成為止。(雖然如此，因為有限性的關係，所以至多系統也只會到9999題為止)")
                .setPositiveButton("下一頁", new DialogInterface.OnClickListener() {@Override public void onClick(DialogInterface dialog, int which) {adExp3.show();}});
        adExp1 = new AlertDialog.Builder(this)
                .setTitle("說明")
                .setMessage("由於字義選擇的四選一題目可以透過辨識選項的方式來答題，" +
                            "所以這可能無法完全檢視自己是否了解、熟悉該單字，因此，在記憶練習中除了會照常出題之外" +
                            "這裡將四選項改成了YES、NO按鈕。")
                .setPositiveButton("下一頁", new DialogInterface.OnClickListener() {@Override public void onClick(DialogInterface dialog, int which) {adExp2.show();}});
        adExp1.show();
    }

    //當【開始練習】按鈕按下時
    public void btnStartTest2_Click(View view) {
        if (qualified) {
            Intent it = new Intent(this, ActMemoryPractice.class);
            it.putExtra("Selection", selection);
            it.putExtra("mode", rdoKeepPractice.isChecked());
            if (rdoQuestions.isChecked())
                it.putExtra("questions", Integer.parseInt(txtQAmount2.getText().toString()));
            it.putExtra("timelimit", skbTimeSet2.getProgress() * 1000);
            startActivity(it);
        }

    }

    //##SeekBar滑桿物件的事件處理副程式##
    //當滑桿滑動時
    @Override
    public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        if(progress>0)
            lblTimePerQ2.setText("每題答題時間: "+progress+"秒");
        else
            lblTimePerQ2.setText("每題答題時間: 無限制");
    }

    @Override
    public void onStartTrackingTouch(SeekBar seekBar) {}
    @Override
    public void onStopTrackingTouch(SeekBar seekBar) {}
    //#####################################
}
