package com.example.leeyuanair.englishhelper.act_spelling;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.example.leeyuanair.englishhelper.MainActivity;
import com.example.leeyuanair.englishhelper.R;

import java.util.ArrayList;
import java.util.Random;

public class ActSpellingExamine extends AppCompatActivity {
    //Global Variables
    int groupIndex;                     //所選的單字群組的編號
    int maxQ, Q;                       //總題數, 目前題號
    boolean prefix, suffix;              //是否啟用字首、字尾提示
    int rights;                           //答對題數
    ArrayList<String> QuestionList;      //題目清單
    ArrayList<String> UserAnswerList;   //使用者的回答清單
    //LinearLayout直線型排版容器
    LinearLayout[] linPartOfSpeech;
    //TextView文字標籤元件
    TextView[] lblPartOfSpeech;
    TextView lblSpellingStatus1;
    TextView lblSpellingStatus2;
    TextView lblQuestionMessage;
    //EditText文字編輯元件
    EditText txtAnswerBar;
    //AlertDialog對話框物件
    AlertDialog.Builder response;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_act_spelling_examine);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        setTitle("拼字測驗");
        //##連結直線型排版容器 並 初始化陣列
        try {
            linPartOfSpeech = new LinearLayout[5];
            linPartOfSpeech[0] = (LinearLayout) findViewById(R.id.linQNoun);
            linPartOfSpeech[1] = (LinearLayout) findViewById(R.id.linQAdjective);
            linPartOfSpeech[2] = (LinearLayout) findViewById(R.id.linQVerb);
            linPartOfSpeech[3] = (LinearLayout) findViewById(R.id.linQAdverb);
            linPartOfSpeech[4] = (LinearLayout) findViewById(R.id.linQPreposition);
            //##連結文字標籤元件 並 初始化陣列
            lblPartOfSpeech = new TextView[5];
            lblPartOfSpeech[0] = (TextView) findViewById(R.id.lblQNoun);
            lblPartOfSpeech[1] = (TextView) findViewById(R.id.lblQAdjective);
            lblPartOfSpeech[2] = (TextView) findViewById(R.id.lblQVerb);
            lblPartOfSpeech[3] = (TextView) findViewById(R.id.lblQAdverb);
            lblPartOfSpeech[4] = (TextView) findViewById(R.id.lblQPreposition);
            lblSpellingStatus1 = (TextView) findViewById(R.id.lblSpellingStatus1);
            lblSpellingStatus2 = (TextView) findViewById(R.id.lblSpellingStatus2);
            lblQuestionMessage = (TextView) findViewById(R.id.lblQuestionMessage);
            //##連結文字編輯元件
            txtAnswerBar = (EditText) findViewById(R.id.txtAnswerBar);
            //##初始化對話框
            response = new AlertDialog.Builder(this);
            response.setCancelable(false);
            response.setPositiveButton("OK", new DialogInterface.OnClickListener() {@Override public void onClick(DialogInterface dialog, int which) {}});
            //取得資料
            Bundle msg = getIntent().getExtras();
            groupIndex = msg.getInt("selection");
            maxQ = msg.getInt("questions");
            prefix = msg.getBoolean("prefix");
            suffix = msg.getBoolean("suffix");
            //建立題目清單
            QuestionGenerator();
            //初始化
            UserAnswerList = new ArrayList<>();
            Q = 0;
            rights = 0;
            lblSpellingStatus1.setText("總題目: " + maxQ + ", 目前題號: 1");
            AnaliysisQuestion();
            //預備的對話框
            AlertDialog.Builder msgBox = new AlertDialog.Builder(this)
                    .setTitle("預備")
                    .setMessage("若輸入文字時會出現提示字的話，建議先關閉此項功能!" +
                                "按下「Start」即可開始測驗。")
                    .setCancelable(false)
                    .setPositiveButton("Start", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                        }
                    });
            msgBox.show();
        }catch(Exception ex){
            Toast.makeText(ActSpellingExamine.this, ex.toString(), Toast.LENGTH_SHORT).show();
        }
    }

    //程序 - 題目生成器
    void QuestionGenerator(){
        QuestionList = new ArrayList<>();
        ArrayList<String> sourceGroup = (groupIndex>=0) ? MainActivity.GROUPS.get(MainActivity.GROUP_NAMES.get(groupIndex)) : MainActivity.WORDS;
        for(int i=1;i<=(maxQ/sourceGroup.size())+1;i++)
            QuestionList.addAll(randomizeGroup(sourceGroup));
    }
    //題目生成器 -> 函式 - 回傳打亂過的新的清單
    ArrayList<String> randomizeGroup(ArrayList<String> sourceGroup){
        ArrayList<String> rndList = (ArrayList<String>) sourceGroup.clone();
        Random rnd = new Random(); rnd.setSeed(rnd.nextInt(100));
        String temp; int num;
        for(int i=rndList.size()-1;i>0;i--){
            num = rnd.nextInt(i+1);
            temp = rndList.get(num);
            rndList.set(num, rndList.get(i));
            rndList.set(i, temp);
        }
        return rndList;
    }

    //程序 - 解析題目中的單字
    void AnaliysisQuestion(){
        String word = QuestionList.get(Q);
        String[] partOfSpeech = MainActivity.ALL_WORDS.get(word);
        for(int i=0;i<5;i++){
            if(partOfSpeech[i]!=null){
                ViewGroup.LayoutParams lay = linPartOfSpeech[i].getLayoutParams();
                lay.height=180;
                linPartOfSpeech[i].setLayoutParams(lay);
                lblPartOfSpeech[i].setText(partOfSpeech[i]);
            }else{
                ViewGroup.LayoutParams lay = linPartOfSpeech[i].getLayoutParams();
                lay.height=0;
                linPartOfSpeech[i].setLayoutParams(lay);
            }
        }
        lblQuestionMessage.setText("#此單字長度為"+word.length()+"，有以下詞性意義:");
        //依條件來生成提示
        txtAnswerBar.setHint((prefix ? word.charAt(0) : "_")+"_____________"+((suffix && word.length()>4) ? word.charAt(word.length()-1) : "_"));
    }

    //當【提交答案】按鈕按下時
    public void btnAnswerIt_Click(View view) {
        // 隱藏螢幕鍵盤
        InputMethodManager imm = (InputMethodManager)getSystemService(Context.INPUT_METHOD_SERVICE);
        imm.hideSoftInputFromWindow(view.getWindowToken(), 0);
        try {
            //將使用者的答案增加至UserAnswerList中
            UserAnswerList.add(txtAnswerBar.getText().toString().trim());
            if (QuestionList.get(Q).equals(UserAnswerList.get(Q))) {
                rights++;
                response.setTitle("答案正確!");
                response.setMessage(QuestionList.get(Q));
            } else {
                response.setTitle("答案錯誤!");
                response.setMessage("正確答案: " + QuestionList.get(Q) +
                        "\r\n你的答案: " + UserAnswerList.get(Q));
            }
            //題目序號+1
            Q++;
            //如果還有題目的話
            if (Q < maxQ) {
                //更新題目
                AnaliysisQuestion();
                txtAnswerBar.setText("");
                //更新狀態
                lblSpellingStatus2.setText("總題目: " + maxQ + ", 目前題號: " + (Q + 1));
                lblSpellingStatus1.setText("答對題數: " + rights + ", 答錯題數: " + (Q - rights));
            } else {
                response.setPositiveButton("測驗完成", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        Intent it = new Intent(ActSpellingExamine.this, ActSpellingResult.class);
                        it.putExtra("maxQ", maxQ);
                        it.putExtra("rights", rights);
                        it.putExtra("QuestionList", QuestionList);
                        it.putExtra("UserAnswerList", UserAnswerList);
                        startActivityForResult(it, 0);
                    }
                });
            }
            response.show();
        }catch(Exception ex){
            Toast.makeText(ActSpellingExamine.this, ex.toString(), Toast.LENGTH_SHORT).show();
        }
    }

    //當下一層的頁面關閉時
    @Override
    protected void onActivityResult(int requestCode, int resultCode,  Intent data) {
        finish();
    }

    //攔截使用者所按下的按鍵 - 包含返回、家、視窗等等按鍵
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event){
        if(keyCode == KeyEvent.KEYCODE_BACK){
            AlertDialog.Builder checker = new AlertDialog.Builder(this)
                    .setTitle("確定離開測驗?")
                    .setMessage("若中途離開此測驗將看不到所測的結果。")
                    .setPositiveButton("Yes", new DialogInterface.OnClickListener() {@Override public void onClick(DialogInterface dialog, int which) {finish();}})
                    .setNegativeButton("No", new DialogInterface.OnClickListener() {@Override public void onClick(DialogInterface dialog, int which) {}});
            checker.show();
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }


}
