package com.example.leeyuanair.englishhelper.act_spelling;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.pm.ActivityInfo;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.example.leeyuanair.englishhelper.MainActivity;
import com.example.leeyuanair.englishhelper.R;

import java.util.ArrayList;

public class ActSpellingResult extends AppCompatActivity implements ListView.OnItemClickListener{
    //Global Variables
    ArrayList<String> QuestionList;
    ArrayList<String> UserAnswerList;
    //ListView清單元件
    ListView lstAnswerLog2;
    //AlertDialog對話框元件
    AlertDialog.Builder msgBox;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_act_spelling_result);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        setTitle("拼字測驗 - 測驗結果");
        //##連結清單元件
        lstAnswerLog2 = (ListView) findViewById(R.id.lstAnswerLog2);
        lstAnswerLog2.setOnItemClickListener(this);
        //##初始化對話框物件
        msgBox = new AlertDialog.Builder(this)
                .setPositiveButton("OK", new DialogInterface.OnClickListener() {@Override public void onClick(DialogInterface dialog, int which) {}});
        //##取得結果資料
        Bundle msg = getIntent().getExtras();
        //利用變數傳址的方法來立即地修改元件屬性
        ((TextView) findViewById(R.id.lblQuestionAmount3)).setText(String.valueOf(msg.getInt("maxQ")));
        ((TextView) findViewById(R.id.lblRights2)).setText(String.valueOf(msg.getInt("rights")));
        ((TextView) findViewById(R.id.lblWrongs2)).setText(String.valueOf(msg.getInt("maxQ") - msg.getInt("rights")));
        //取得問題清單 及 使用者回答結果
        QuestionList = (ArrayList<String>) msg.get("QuestionList");
        UserAnswerList = (ArrayList<String>) msg.get("UserAnswerList");
        ArrayAdapter<String> logAdapter = new ArrayAdapter<>(this, android.R.layout.simple_list_item_1);
        try {
            for (int i = 0; i < UserAnswerList.size(); i++) {
                logAdapter.add((QuestionList.get(i).equals(UserAnswerList.get(i)) ? "O " : "X ") +
                        (i + 1) + ". " + QuestionList.get(i));
            }
            lstAnswerLog2.setAdapter(logAdapter);
        }catch(Exception ex){
            Toast.makeText(ActSpellingResult.this, ex.toString(), Toast.LENGTH_SHORT).show();
        }
    }

    //當lstAnswerLog2內的清單項按下時
    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        String word = QuestionList.get(position);
        String[] partOfSpeech = MainActivity.ALL_WORDS.get(word);
        boolean isRight = (word.equals(UserAnswerList.get(position)));
        msgBox.setTitle(isRight ? "此題答對" : "此題答錯");
        msgBox.setMessage("正確答案: "+word+(isRight ? "\r\n" : "\r\n你的答案: "+UserAnswerList.get(position)+"\r\n") +
                            (partOfSpeech[0]!=null ? "\r\n名詞(n.) "+partOfSpeech[0] : "") +
                            (partOfSpeech[1]!=null ? "\r\n形容詞(adj.) "+partOfSpeech[1] : "") +
                            (partOfSpeech[2]!=null ? "\r\n動詞(v.) "+partOfSpeech[2] : "") +
                            (partOfSpeech[3]!=null ? "\r\n副詞(adv.) "+partOfSpeech[3] : "") +
                            (partOfSpeech[4]!=null ? "\r\n介係詞(prep.) "+partOfSpeech[4] : ""));
        msgBox.show();
    }

    //當【返回至設定頁面】按鈕按下時
    public void btnBack9_Click(View view) {finish();}

}
