package com.example.leeyuanair.englishhelper.act_spelling;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.graphics.Color;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.TextView;

import com.example.leeyuanair.englishhelper.MainActivity;
import com.example.leeyuanair.englishhelper.R;

import java.util.ArrayList;

public class ActSpellingSetting extends AppCompatActivity {
    //Global Variables
    int selection;                  //紀錄使用者所選擇的群組的編號
    boolean qualified;             //表示所選的單字群組是否符合基本要求(單字量大於4個)
    //Button按鈕元件
    Button btnChangeGroup3;
    //TextView文字標籤元件
    TextView lblExtraMsg3;
    //EditText文字編輯元件
    EditText txtQAmount3;
    //CheckBox勾選元件
    CheckBox chkPrefix, chkSuffix;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_act_spelling_setting);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        setTitle("拼字測驗 - 測驗設定");
        //連結按鈕元件
        btnChangeGroup3 = (Button) findViewById(R.id.btnChangeGroup3);
        //連結文字標籤元件
        lblExtraMsg3 = (TextView) findViewById(R.id.lblExtraMsg3);
        //連結文字編輯元件
        txtQAmount3 = (EditText) findViewById(R.id.txtQAmount3);
        //連結勾選元件
        chkPrefix = (CheckBox) findViewById(R.id.chkPrefix);
        chkSuffix = (CheckBox) findViewById(R.id.chkSuffix);
        //初始化變數
        selection=-1;
        qualified=true;
    }

    //當btnChangeGroup3按鈕按下時
    public void btnChangeGroup3_Click(View view) {
        final ArrayList<String> ad = new ArrayList<String>();
        ad.add("所有單字"); ad.addAll(MainActivity.GROUP_NAMES);
        AlertDialog.Builder alert = new AlertDialog.Builder(this)
                .setTitle("選擇群組")
                .setAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, ad), new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        selection=which-1;
                        btnChangeGroup3.setText(ad.get(which));
                        if(selection>=0){
                            ArrayList<String> SelGroup = MainActivity.GROUPS.get(MainActivity.GROUP_NAMES.get(selection));
                            qualified=SelGroup.size()>4;
                            if(qualified){
                                lblExtraMsg3.setTextColor(Color.argb(255,168,168,168));
                                if(chkSuffix.isChecked() || chkPrefix.isChecked()){
                                    lblExtraMsg3.setText("如果某項單字長度小於5的話，題目只會提供字首或不提供");
                                }else{
                                    lblExtraMsg3.setText("");
                                }
                            }else{
                                lblExtraMsg3.setTextColor(Color.RED);
                                lblExtraMsg3.setText("單字群組內的單字量必須大於4個。");
                            }
                        }else{
                            qualified=true;
                            lblExtraMsg3.setTextColor(Color.argb(255,168,168,168));
                            if(chkSuffix.isChecked() || chkPrefix.isChecked()){
                                lblExtraMsg3.setText("如果某項單字長度小於5的話，題目只會提供字首或不提供");
                            }else{
                                lblExtraMsg3.setText("");
                            }
                        }
                    }
                });
        alert.show();
    }

    //當【+】按鈕按下時
    public void btnAdd3_Click(View view) {
        int num = Integer.parseInt(txtQAmount3.getText().toString()) + 1;
        txtQAmount3.setText(String.valueOf(num<10000 ? num : 9999));
    }

    //當【-】按鈕按下時
    public void btnSubtract3_Click(View view) {
        int num = Integer.parseInt(txtQAmount3.getText().toString()) - 1;
        txtQAmount3.setText(String.valueOf(num>0 ? num : 1));
    }

    //當【字首提示】勾選元件按下時
    public void chkPrefix_Click(View view) {
        if(qualified){
            if(chkSuffix.isChecked() || chkPrefix.isChecked()){
                lblExtraMsg3.setText("如果某項單字長度小於5的話，題目只會提供字首或不提供");
            }else{
                lblExtraMsg3.setText("");
            }
        }
    }

    //當【字尾提示】勾選元件按下時
    public void chkSuffix_Click(View view) {
        if(qualified){
            if(chkSuffix.isChecked() || chkPrefix.isChecked()){
                lblExtraMsg3.setText("如果某項單字長度小於5的話，題目只會提供字首或不提供");
            }else{
                lblExtraMsg3.setText("");
            }
        }
    }

    //當【開始測驗】按鈕按下時
    public void btnStartTest3_Click(View view) {
        if(qualified){
            Intent it = new Intent(this, ActSpellingExamine.class);
            it.putExtra("selection", selection);
            it.putExtra("questions", Integer.valueOf(txtQAmount3.getText().toString()));
            it.putExtra("prefix", chkPrefix.isChecked());
            it.putExtra("suffix", chkSuffix.isChecked());
            startActivity(it);
        }
    }

    //當【說明】按鈕按下時
    public void btnExplanation3_Click(View view) {
        final AlertDialog.Builder adExp1, adExp2, adExp3;
        adExp3 = new AlertDialog.Builder(this)
                .setTitle("說明")
                .setMessage("在設定的部分，你可以選擇單字群組、設定題目數量與是否提示字首、字尾。" +
                            "由於每個英文單字的長短個不同，因此次測驗不設置限時選項。設定完之後就可以開始進行測驗了。")
                .setPositiveButton("完成", new DialogInterface.OnClickListener() {@Override public void onClick(DialogInterface dialog, int which) {}});
        adExp2 = new AlertDialog.Builder(this)
                .setTitle("說明")
                .setMessage("測驗時只要針對題目所示的詞性意思來寫出正確的英文單字即可。" +
                            "若有字首或字尾的單字提示，在回答時仍須將其寫出。")
                .setPositiveButton("下一頁", new DialogInterface.OnClickListener() {@Override public void onClick(DialogInterface dialog, int which) {adExp3.show();}});
        adExp1 = new AlertDialog.Builder(this)
                .setTitle("說明")
                .setMessage("除了了解單字字義之外，英文的拼寫也是相當地重要。在此測驗中，" +
                            "系統會隨機選擇群組中的單字並秀出其所有的詞性意思。")
                .setPositiveButton("下一頁", new DialogInterface.OnClickListener() {@Override public void onClick(DialogInterface dialog, int which) {adExp2.show();}});
        adExp1.show();
    }

    //當【返回】按鈕按下時
    public void btnBack7_Click(View view) {finish();}

}
